/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import gui.myTextArea;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;

/**
 *
 * @author pchr
 */
public class member {
    private int id;
    private point P1;
    private point P2;
    private material theMaterial;
    private section theSection;
    private structure theStructure;
    private String name;
    
    public member(){};
    
    public member(int id, point P1, point P2, material theMaterial, section theSection,String name){
        this.id=id;
        this.P1=P1;
        this.P2=P2;
        this.theMaterial=theMaterial;
        this.theSection=theSection;
        this.name=name;
    }
    
    public void setStructure(structure theStructure){
        this.theStructure=theStructure;
    }
    
    public point getP1(){
        return this.P1;
    }
    
    public point getP2(){
        return this.P2;
    }
    
    public point getPoint(int w){
        point p ;
        switch(w){
            case 0: p = this.P1; break;
            default:p = this.P2; break;
        }
        return p;
    }
    
    public double getL(){
        return Math.sqrt((P1.getX()-P2.getX())*(P1.getX()-P2.getX())+(P1.getY()-P2.getY())*(P1.getY()-P2.getY()));
    }
    
    public section getSection(){
        return this.theSection;
    }
  
    public double[] getM1(){
        int theId=this.id;
        double[] val=new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double sec=1./cos;
        double tan=sin/cos;
        //double X1=this.theStructure.getX1();
        //double X2=this.theStructure.getX2();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        //double q=this.theStructure.getQ();
        //double P=this.theStructure.getP();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: val[0]=0.; val[1]=0.; val[2]=0.; break;
            case 2: val[0]=L*L*L/(3.*cos); val[1]=-L*L*(12.*H+8.*L*tan)/(24.*cos); val[2]=-L*L*L/(8.*cos); break;
            case 3: val[0]=1./3.*coef*(3.+coef*(3.+coef))*L*L*L*sec;
                    val[1]=-1./12.*coef*L*L*sec*(6.*(2.+coef)*H-4.*(-3+coef*coef)*L*tan);
                    val[2]=-(coef*(6.+coef*(9.+4*coef))*L*L*L*sec)/12.;
                    break;
            case 4: val[0]=-1./3.*(-1.+coef)*(7.+coef*(4.+coef))*L*L*L*sec;
                    val[1]=1./12.*(-1.+coef)*L*L*sec*(6.*(3.+coef)*H-4.*(-1.+coef)*(2.+coef)*L*tan);
                    val[2]=1./12.*(-1.+coef)*L*L*sec*((19.+coef*(13.+4*coef))*L-2.*(-1.+coef)*(5.+coef)*L*tan);
                    break;
            case 5: val[0]=4.*H*L*L; val[1]=-H*H*L; val[2]=-H*L*(H+3.*L-2.*(-1.+coef)*L*tan); break;
        }
        for(int i=0;i<val.length;i++){
            val[i]=val[i]/(this.theMaterial.getElast()*this.theSection.getI());
        }
        return val;
    }
    
    public double[] getM2(){
        int theId=this.id;
        double[] val=new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double sec=1./cos;
        double tan=sin/cos;
        //double X1=this.theStructure.getX1();
        //double X2=this.theStructure.getX2();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        //double q=this.theStructure.getQ();
        //double P=this.theStructure.getP();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: val[0]=0.; val[1]=H*H*H/3.; val[2]=0.; break;
            case 2: val[0]=1/24.*L*sec*(-12.*H*L-8.*L*L*tan); 
                    val[1]=1/24.*L*sec*(24.*H*H-8.*L*L+8.*L*L*sec*sec+24.*H*L*tan); 
                    val[2]=1/24.*L*sec*(4*H*L+3.*L*L*tan);
                    break;
            case 3: val[0]=1/12.*coef*L*sec*(-6.*(2.+coef)*H*L+4.*(-3.+coef*coef)*L*L*tan); 
                    val[1]=1/12.*coef*L*sec*(12.*H*H-4.*(3.+(-3.+coef)*coef)*L*L+4.*(3.+(-3.+coef)*coef)*L*L*sec*sec-12.*(-2.+coef)*H*L*tan); 
                    val[2]=1/12.*coef*L*sec*(6.*(1.+coef)*H*L+(6.+(3.-4.*coef)*coef)*L*L*tan);
                    break;
            case 4: val[0]=1/12.*(-1.+coef)*L*sec*(6.*(3.+coef)*H*L-4.*(-1.+coef)*(2.+coef)*L*L*tan);
                    val[1]=1/12.*(-1.+coef)*L*sec*(-12.*H*H+4.*(-1+coef)*(-1+coef)*L*L-4.*(-1.+coef)*(-1.+coef)*L*L*sec*sec+12.*(-1.+coef)*H*L*tan);
                    val[2]=1/12.*(-1.+coef)*L*sec*(2.*(-1.+coef)*(-1.+coef)*L*L-6.*(2.+coef)*H*L-2.*(-1.+coef)*(-1.+coef)*L*L*sec*sec+6.*(-1.+coef)*H*L*tan+(-1.+coef)*(5.+4.*coef)*L*L*tan);
                    break;
            case 5: val[0]=-H*H*L; val[1]=H*H*H/3.; val[2]=1/12.*H*H*(2*H+9.*L-6.*(-1.+coef)*L*tan); break;
        }
        for(int i=0;i<val.length;i++){
            val[i]=val[i]/(this.theMaterial.getElast()*this.theSection.getI());
        }
        return val;
    }
    
    public int getId(){
        return this.id;
    }
    
    public double getMp(){
        return this.theMaterial.getYieldStress()*this.theSection.getWp();
    }
    
    public double[] getMcoefs(double xin){
        //xin apo 0 eos 1
        int theId=this.id;
        double[] vals= new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        double x=this.getL()*xin;
        switch(theId){
            case 1: vals[0]=0.; vals[1]=-x; vals[2]=0.; break;
            case 2: vals[0]=x*cos; vals[1]=-(H+x*sin); vals[2]=-x*x*cos*cos/(2.*L); break;
            case 3: vals[0]=(L+x*cos); vals[1]=-(H+sin*L/cos-x*sin); vals[2]=-(L/2.+x*cos); break;
            //case 4: val=X1*(L+this.getL()*cos+x*cos)-X2*(H+L*sin/cos-this.getL()*sin-x*sin)
            //        -P*x*sin-q*L*(L/2.+this.getL()*cos+x*cos); break;
            case 4: vals[0]=(L+coef*L+x*cos); vals[1]=-(H+L*sin/cos-coef*L*sin/cos-x*sin); vals[2]=-x*sin-(L/2.+coef*L+x*cos); break;
            case 5: vals[0]=2.*L; vals[1]=-(H-x); vals[2]=-L*3./2.-(x+(1.-coef)*L*sin/cos); break;
        }
        return vals;
    }
    
    public double[] getNcoefs(double xin){
        //xin apo 0 eos 1
        int theId=this.id;
        double[] vals= new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double L=this.theStructure.getL();
        double x=this.getL()*xin;
        switch(theId){
            case 1: vals[0]=-1.; vals[1]=0.; vals[2]=0.; break;
            case 2: vals[0]=-sin; vals[1]=-cos; vals[2]=x*sin*cos/L; break;
            case 3: vals[0]=sin; vals[1]=-cos; vals[2]=-sin; break;
            case 4: vals[0]=sin; vals[1]=-cos; vals[2]=-sin+cos; break;
            case 5: vals[0]=1.; vals[1]=0.; vals[2]=-1.; break;
        }
        return vals;
    }
    
    public material getMaterial(){
        return this.theMaterial;
    }
    
    public String getName(){
        return this.name;
    }
    
    public String getPositionName(int whw){
        String s="0";
        switch(whw){
            case 0: s=this.name.substring(0, 1);break;
            case 1: s=this.name.substring(1);break;
        }
        return s;
    }
    
    public double getM(double x, double X1, double X2, double P){
        int theId=this.id;
        double val=0.;
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        //double X1=this.theStructure.getX1();
        //double X2=this.theStructure.getX2();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        //double q=this.theStructure.getQ();
        //double P=this.theStructure.getP();
        double q=P/theStructure.getL();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: val=-x*X2; break;
            case 2: val=X1*x*cos-X2*(H+x*sin)-q*x*x*cos*cos/2.; break;
            case 3: val=X1*(L+x*cos)-X2*(H+sin*L/cos-x*sin)-q*L*(L/2.+x*cos); break;
            //case 4: val=X1*(L+this.getL()*cos+x*cos)-X2*(H+L*sin/cos-this.getL()*sin-x*sin)
            //        -P*x*sin-q*L*(L/2.+this.getL()*cos+x*cos); break;
            case 4: val=X1*(L+coef*L+x*cos)-X2*(H+L*sin/cos-coef*L*sin/cos-x*sin)
                    -P*x*sin-q*L*(L/2.+coef*L+x*cos); break;
            case 5: val=X1*2.*L-X2*(H-x)-q*L*L*3./2.-P*(x+(1.-coef)*L*sin/cos); break;
        }
        return val;
    }
    
    public double getN(double x, double X1, double X2, double P){
        int theId=this.id;
        double val=0.;
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        //double X1=this.theStructure.getX1();
        //double X2=this.theStructure.getX2();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        //double q=this.theStructure.getQ();
        //double P=this.theStructure.getP();
        double q=P/theStructure.getL();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: val=-X1; break;
            case 2: val=-X1*sin-X2*cos+q*x*sin*cos; break;
            case 3: val=X1*sin-X2*cos-q*L*sin; break;
            case 4: val=X1*sin-X2*cos-q*L*sin+P*cos; break;
            case 5: val=X1-q*L; break;
        }
        return val;
    }
    
    public double getQ(double x, double X1, double X2, double P){
        int theId=this.id;
        double val=0.;
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        //double X1=this.theStructure.getX1();
        //double X2=this.theStructure.getX2();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        //double q=this.theStructure.getQ();
        //double P=this.theStructure.getP();
        double q=P/theStructure.getL();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: val=X2; break;
            case 2: val=-X1*cos+X2*sin+q*x*cos*cos; break;
            case 3: val=q*L*cos-X1*cos-X2*sin; break;
            case 4: val=q*L*cos-X1*cos-X2*sin+P*sin; break;
            case 5: val=P-X2; break;
        }
        return val;
    }
    
    public double getMemberCosAngle(){
        double phi=0.;
        double xl=this.P2.getX()-this.P1.getX();
        phi=xl/this.getL();
        return phi;
    }
    
    public double getMemberSinAngle(){
        double phi=0.;
        double xl=this.P2.getY()-this.P1.getY();
        phi=xl/this.getL();
        return phi;
    }
    
    public void print(myTextArea pout){
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.000",comma);
        String sd;
        pout.append("Μέλος :"+this.name+'\n');
        pout.append("διατομή μέλους"+'\n');
        sd=Places.format(this.theSection.getA()*10000.);
        pout.append("A="+sd+"[cm^2]"+'\n');
        sd=Places.format(this.theSection.getI()*100000000.);
        pout.append("I="+sd+"[cm^4]"+'\n');
        sd=Places.format(this.theSection.getHeight()*100.);
        pout.append("h_διατομής="+sd+"[cm]"+'\n');
        sd=Places.format(this.theSection.getWy()*1000000.);
        pout.append("Wy="+sd+"[cm^3]"+'\n');
        sd=Places.format(this.theSection.getWp()*1000000.);
        pout.append("Wp="+sd+"[cm^3]"+'\n');
        pout.append("υλικό μέλους"+'\n');
        sd=Places.format(this.theMaterial.getElast()/1000000.);
        pout.append("E="+sd+"[GPa]"+'\n');
        sd=Places.format(this.theMaterial.getYieldStress()/1000.);
        pout.append("σY="+sd+"[MPa]"+'\n');
        sd=Places.format(this.getMp());
        pout.append("Mp="+sd+"[kNm]"+'\n'+'\n');
    }
    
    public double[] getM2_D(){
        int theId=this.id;
        double[] val=new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sec=1./cos;
        double angle=this.theStructure.getAngle();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: 
                val[0]=0.;
                val[1]=(Math.pow(H,3))/3.;
                val[2]=0.;
                break;
            case 2: 
                val[0]=(L*Math.pow(sec,3)*(-4*H*L - 4*H*L*Math.cos(2*angle) - 8*L*(-H + L)*Math.sin(2*angle)))/48.;
                val[1]=(L*Math.pow(sec,3)*(12*Math.pow(H,2) - 8*H*L + 8*Math.pow(L,2) + 12*Math.pow(H,2)*Math.cos(2*angle) + 8*H*L*Math.cos(2*angle) - 8*Math.pow(L,2)*Math.cos(2*angle) + 4*H*(-3*H + 4*L)*Math.sin(2*angle)))/48.;
                val[2]=(L*Math.pow(sec,3)*(H*L + H*L*Math.cos(2*angle) + 3*L*(-H + L)*Math.sin(2*angle)))/48.;
                break;
            case 3: 
                val[0]=(coef*L*sec*(6*coef*H*L + 4*Math.pow(coef,2)*H*L + 12*H*L*Math.tan(angle) + 4*coef*(3 + coef)*H*L*Math.tan(angle) + 4*(-3 + Math.pow(coef,2))*Math.pow(L,2)*Math.tan(angle)))/12. ;
                val[1]=(coef*L*sec*(-6*coef*Math.pow(H,2) - 4*Math.pow(coef,2)*H*L + 12*(H - L)*L + 12*coef*Math.pow(L,2) - 4*Math.pow(coef,2)*Math.pow(L,2) + 
                4*L*((-3 + Math.pow(coef,2))*H + (3 + (-3 + coef)*coef)*L)*Math.pow(sec,2) - 6*(2 + coef)*Math.pow(H,2)*Math.tan(angle) + 12*H*L*Math.tan(angle) + 4*(-3 + coef)*coef*H*L*Math.tan(angle)))/12.;
                val[2]=(coef*L*sec*(-3*coef*H*L - 4*Math.pow(coef,2)*H*L + (-6 - coef*(9 + 4*coef))*H*L*Math.tan(angle) + (6 + (3 - 4*coef)*coef)*Math.pow(L,2)*Math.tan(angle)))/12.;
                break;
            case 4: 
                val[0]=((-1 + coef)*L*Math.pow(sec,3)*(-2*(5 + coef*(5 + 2*coef))*H*L - 2*(5 + coef*(5 + 2*coef))*H*L*Math.cos(2*angle) - 4*(7 + coef*(4 + coef))*H*L*Math.sin(2*angle) - 
                4*(-1 + coef)*(2 + coef)*Math.pow(L,2)*Math.sin(2*angle)))/24.;
                val[1]=((-1 + coef)*L*Math.pow(sec,3)*(6*(1 + coef)*Math.pow(H,2) - 4*(-2 + coef + Math.pow(coef,2))*H*L - 4*Math.pow(-1 + coef,2)*Math.pow(L,2) + 6*(1 + coef)*Math.pow(H,2)*Math.cos(2*angle) + 
                4*(-2 + coef + Math.pow(coef,2))*H*L*Math.cos(2*angle) + 4*Math.pow(-1 + coef,2)*Math.pow(L,2)*Math.cos(2*angle) + 6*(3 + coef)*Math.pow(H,2)*Math.sin(2*angle) - 4*Math.pow(-1 + coef,2)*H*L*Math.sin(2*angle)))
                /24.;
                val[2]=((-1 + coef)*L*Math.pow(sec,3)*((17 + coef*(-1 + 2*coef))*H*L - 2*Math.pow(-1 + coef,2)*Math.pow(L,2) + 3*(-1 + coef*(5 + 2*coef))*H*L*Math.cos(2*angle) + 
                2*Math.pow(-1 + coef,2)*Math.pow(L,2)*Math.cos(2*angle) + (23 + coef*(11 + 2*coef))*H*L*Math.sin(2*angle) + (-1 + coef)*(5 + 4*coef)*Math.pow(L,2)*Math.sin(2*angle)))/24.;
                break;
            case 5: 
                val[0]=-(Math.pow(H,2)*(-36*L - 48*L*Math.tan(angle)))/12.;
                val[1]=-(Math.pow(H,2)*(8*H + 12*H*Math.tan(angle)))/12.;
                val[2]=-(Math.pow(H,2)*(10*H + 3*L + 24*coef*L - 24*(-1 + coef)*L*Math.pow(sec,2) + 12*H*Math.tan(angle) - 18*(-3 + coef)*L*Math.tan(angle)))/12.;
                break;
        }
        for(int i=0;i<val.length;i++){
            val[i]=val[i]/(this.theMaterial.getElast()*this.theSection.getI());
        }
        return val;
    }
    
    public double[] getM2_Z(){
        //System.out.println("Z-CASE");
        int theId=this.id;
        double[] val=new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sec=1./cos;
        double angle=this.theStructure.getAngle();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: 
                val[0]=0.;
                val[1]=(Math.pow(H,3))/3.;
                val[2]=0.;
                break;
            case 2: 
                val[0]=(L*sec*(-4*H*L - 12*coef*H*L - 8*L*((-1 + coef)*H + L + coef*L)*Math.tan(angle)))/(24.*(1 + coef));
                val[1]=(L*sec*(12*(1 + 2*coef)*Math.pow(H,2) - 8*(-1 + coef)*H*L - 8*(1 + coef)*Math.pow(L,2) + 8*L*((-1 + coef)*H + L + coef*L)*Math.pow(sec,2) + 
                4*H*(3*(-1 + coef)*H + 4*L + 6*coef*L)*Math.tan(angle)))/(24.*(1 + coef));
                val[2]=(L*sec*(H*L + 4*coef*H*L + 3*L*((-1 + coef)*H + L + coef*L)*Math.tan(angle)))/(24.*(1 + coef));
                break;
            case 3: 
                val[0]=(coef*L*Math.pow(sec,3)*(-6*(-1 + coef)*coef*H*L - 6*(-1 + coef)*coef*H*L*Math.cos(2*angle) - 24*L*Math.cos(angle)*(coef*H*Math.cos(angle) + ((-1 + coef)*H + L + coef*L)*Math.sin(angle)) + 
                8*Math.pow(coef,2)*L*Math.cos(angle)*(H*Math.cos(angle) + (H - coef*H + L + coef*L)*Math.sin(angle)) - 12*(-1 + coef)*coef*H*L*Math.sin(2*angle)))/(24.*(1 + coef));
                val[1]=(coef*L*Math.pow(sec,3)*(-6*coef*Math.pow(H,2) - 12*coef*(1 + coef)*Math.pow(L,2) - 6*coef*Math.pow(H,2)*Math.cos(2*angle) + 12*coef*(1 + coef)*Math.pow(L,2)*Math.cos(2*angle) + 
                24*H*Math.cos(angle)*(coef*H*Math.cos(angle) + ((-1 + coef)*H + L + coef*L)*Math.sin(angle)) + 24*L*Math.sin(angle)*(coef*H*Math.cos(angle) + ((-1 + coef)*H + L + coef*L)*Math.sin(angle)) + 
                8*Math.pow(coef,2)*L*Math.sin(angle)*(H*Math.cos(angle) + (H - coef*H + L + coef*L)*Math.sin(angle)) + 6*(-1 + coef)*coef*Math.pow(H,2)*Math.sin(2*angle) - 12*coef*(1 + coef)*H*L*Math.sin(2*angle)))/
                (24.*(1 + coef));
                val[2]=(coef*L*Math.pow(sec,3)*(-3*coef*H*L + 6*Math.pow(coef,2)*H*L - 3*coef*H*L*Math.cos(2*angle) + 6*Math.pow(coef,2)*H*L*Math.cos(2*angle) + 
                12*L*Math.cos(angle)*(coef*H*Math.cos(angle) + ((-1 + coef)*H + L + coef*L)*Math.sin(angle)) - 8*Math.pow(coef,2)*L*Math.cos(angle)*(H*Math.cos(angle) + (H - coef*H + L + coef*L)*Math.sin(angle)) + 
                9*(-1 + coef)*coef*H*L*Math.sin(2*angle) + 3*coef*(1 + coef)*Math.pow(L,2)*Math.sin(2*angle)))/(24.*(1 + coef));
                break;
            case 4: 
                val[0]=-(Math.pow(-1 + coef,2)*L*Math.pow(sec,3)*(-2*(5 + coef)*H*L - 2*(5 + coef)*H*L*Math.cos(2*angle) - 4*(7 + coef*(4 + coef))*H*L*Math.sin(2*angle) - 
                4*(-1 - coef)*(2 + coef)*Math.pow(L,2)*Math.sin(2*angle)))/(24.*(1 + coef));
                val[1]=-(Math.pow(-1 + coef,2)*L*Math.pow(sec,3)*(6*Math.pow(H,2) - 4*(-2 + coef + Math.pow(coef,2))*H*L + 4*(-1 + Math.pow(coef,2))*Math.pow(L,2) + 6*Math.pow(H,2)*Math.cos(2*angle) + 
                4*(-2 + coef + Math.pow(coef,2))*H*L*Math.cos(2*angle) - 4*(-1 + Math.pow(coef,2))*Math.pow(L,2)*Math.cos(2*angle) + 6*(3 + coef)*Math.pow(H,2)*Math.sin(2*angle) - 4*H*L*Math.sin(2*angle) - 
                8*coef*H*L*Math.sin(2*angle)))/(24.*(1 + coef));
                val[2]=-(Math.pow(-1 + coef,2)*L*Math.pow(sec,3)*((17 - 2*coef*(3 + coef))*H*L + 2*(-1 + Math.pow(coef,2))*Math.pow(L,2) + (-3 + 2*coef*(5 + coef))*H*L*Math.cos(2*angle) - 
                2*(-1 + Math.pow(coef,2))*Math.pow(L,2)*Math.cos(2*angle) + (23 + coef*(9 + 4*coef))*H*L*Math.sin(2*angle) + (-1 - coef)*(5 + 4*coef)*Math.pow(L,2)*Math.sin(2*angle)))/(24.*(1 + coef));
                break;
            case 5: 
                val[0]=(Math.pow(H,2)*(-12*(-3 + coef)*L - 48*(-1 + coef)*L*Math.tan(angle)))/(12.*(1 + coef));
                val[1]=(Math.pow(H,2)*(4*(-2 + coef)*H + 12*(-1 + coef)*H*Math.tan(angle)))/(12.*(1 + coef));
                val[2]=(Math.pow(H,2)*(2*(-5 + coef)*H + 9*(-3 + coef)*L + 12*(-1 + coef)*H*Math.tan(angle) - 6*(-9 + coef)*(-1 + coef)*L*Math.tan(angle) - 24*Math.pow(-1 + coef,2)*L*Math.pow(Math.tan(angle),2)))/
                (12.*(1 + coef));
                break;
        }
        for(int i=0;i<val.length;i++){
            val[i]=val[i]/(this.theMaterial.getElast()*this.theSection.getI());
        }
        return val;
    }
    
    public double[] getM2_G(){
        int theId=this.id;
        double[] val=new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sec=1./cos;
        double angle=this.theStructure.getAngle();
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: 
                val[0]=0.;
                val[1]=(Math.pow(H,3))/3.;
                val[2]=0.;
                break;
            case 2: 
                val[0]=(L*sec*(-16*H*L - 16*Math.pow(L,2)*Math.tan(angle)))/48.;
                val[1]=(L*sec*(36*Math.pow(H,2) - 16*Math.pow(L,2) + 16*Math.pow(L,2)*Math.pow(sec,2) + 40*H*L*Math.tan(angle)))/48.;
                val[2]=(L*sec*(5*H*L + 6*Math.pow(L,2)*Math.tan(angle)))/48.;
                break;
            case 3: 
                val[0]=(coef*(-3 + Math.pow(coef,2))*Math.pow(L,2)*sec*(H + 2*L*Math.tan(angle)))/6.;
                val[1]=(coef*L*sec*(H + 2*L*Math.tan(angle))*(-6*(-2 + coef)*H + 4*(3 + (-3 + coef)*coef)*L*Math.tan(angle)))/24.;
                val[2]=(coef*(6 + (3 - 4*coef)*coef)*Math.pow(L,2)*sec*(H + 2*L*Math.tan(angle)))/24.;
                break;
            case 4: 
                val[0]=-(Math.pow(-1 + coef,2)*(2 + coef)*Math.pow(L,2)*sec*(H + 2*L*Math.tan(angle)))/6.;
                val[1]=(Math.pow(-1 + coef,2)*L*sec*(H + 2*L*Math.tan(angle))*(6*H - 4*(-1 + coef)*L*Math.tan(angle)))/24.;
                val[2]=(Math.pow(-1 + coef,2)*L*sec*(H + 2*L*Math.tan(angle))*((5 + 4*coef)*L - 2*(-1 + coef)*L*Math.tan(angle)))/24.;
                break;
            case 5: 
                val[0]=-(Math.pow(H,2)*L);
                val[1]=Math.pow(H,3)/3.;
                val[2]=(Math.pow(H,2)*(2*H + 9*L - 6*(-1 + coef)*L*Math.tan(angle)))/12.;
                break;
        }
        for(int i=0;i<val.length;i++){
            val[i]=val[i]/(this.theMaterial.getElast()*this.theSection.getI());
        }
        return val;
    }
    
    public double getM_isostatic(double x, double X1, double X2, double P){
        int theId=this.id;
        double val=0.;
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        switch(theId){
            case 1: val=-x*X2; break;
            case 2: val=X1*x*cos-X2*(H+x*sin); break;
            case 3: val=X1*(L+x*cos)-X2*(H+sin*L/cos-x*sin); break;
            case 4: val=X1*(L+coef*L+x*cos)-X2*(H+L*sin/cos-coef*L*sin/cos-x*sin); break;
            case 5: val=X1*2.*L-X2*(H-x)-P*x; break;
        }
        return val;
    }
    
    /*public double[] getMcoefs_isostatic(double xin){
        //xin apo 0 eos 1
        int theId=this.id;
        double[] vals= new double[3];
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        double x=this.getL()*xin;
        switch(theId){
            case 1: vals[0]=0.; vals[1]=-x; vals[2]=0.; break;
            case 2: vals[0]=x*cos; vals[1]=-(H+x*sin); vals[2]=0.; break;
            case 3: vals[0]=(L+x*cos); vals[1]=-(H+sin*L/cos-x*sin); vals[2]=0.; break;
            case 4: vals[0]=(L+coef*L+x*cos); vals[1]=-(H+L*sin/cos-coef*L*sin/cos-x*sin); vals[2]=0.; break;
            case 5: vals[0]=2.*L; vals[1]=-(H-x); vals[2]=x; break;
        }
        return vals;
    }*/
    
    public double getM_mult(double X1, double X2, double P, double M0, double M1){
        int theId=this.id;
        double val=0.;
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        double sec=1./cos;
        double angle=this.theStructure.getAngle();
        switch(theId){
            case 1: val=-(Math.pow(H,2)*M0*X2)/2. + (Math.pow(H,3)*M0*X2*Math.cos(angle))/(3.*L) - (Math.pow(H,3)*M1*X2*Math.cos(angle))/(3.*L); break;
            case 2: val=-(L*Math.pow(sec,3)*(-(L*(M0 - M1)*(3*L*P - 8*L*X1 + 12*H*X2)*Math.cos(angle)) + 
            2*(H*M0*(L*(P - 3*X1) + 6*H*X2)*Math.cos(2*angle) - 4*Math.pow(L,2)*(M0 - M1)*X2*Math.sin(angle) + H*M0*(L*P - 3*L*X1 + 6*H*X2 + 3*L*X2*Math.sin(2*angle)))))/(24.*H); break;
            case 3: val=-(coef*L*sec*(L*((3 + 2*coef)*M0 + (3 + 4*coef)*M1)*P - 2*L*((3 + coef)*M0 + (3 + 2*coef)*M1)*X1 + 6*H*(M0 + M1)*X2 - 
            2*L*((-3 + coef)*M0 + (-3 + 2*coef)*M1)*X2*Math.tan(angle)))/12.; break;
            case 4: val=-((-1 + coef)*L*sec*(L*(M0*(-((5 + 4*coef)*P) + 4*(2 + coef)*X1) + M1*(-((7 + 2*coef)*P) + 2*(5 + coef)*X1)) - 6*H*(M0 + M1)*X2 + 
            2*(-1 + coef)*L*(M1*(2*P + X2) + M0*(P + 2*X2))*Math.tan(angle)))/12.; break;
            case 5: val=-(H*(3*L*(M0 + M1)*(3*P - 4*X1) + 2*H*(M0*P + 2*M1*P + 2*M0*X2 + M1*X2) - 6*(-1 + coef)*L*(M0 + M1)*P*Math.tan(angle)))/12.; break;
        }
        val=val/(this.theMaterial.getElast()*this.theSection.getI());
        return val;
    }
    
    public double getM_mult_iso(double M0, double M1, double MM0, double MM1){
        int theId=this.id;
        double val=0.;
        double cos=Math.cos(this.theStructure.getAngle());
        double sin=Math.sin(this.theStructure.getAngle());
        double H=this.theStructure.getH();
        double L=this.theStructure.getL();
        double coef=this.theStructure.getCoef();
        double sec=1./cos;
        double angle=this.theStructure.getAngle();
        switch(theId){
            case 1: val=(H*(6*Math.pow(L,2)*M0*MM0 + Math.pow(H,2)*(M0 - M1)*(MM0 - MM1) + 3*H*L*(M1*MM0 + M0*(-2*MM0 + MM1))*Math.cos(angle) + Math.pow(H,2)*(M0 - M1)*(MM0 - MM1)*Math.cos(2*angle)))/(6.*Math.pow(L,2)); break;
            case 2: val=(L*sec*(6*Math.pow(H,2)*M0*MM0 + 3*H*L*(M1*MM0 + M0*(-2*MM0 + MM1))*sec + 2*Math.pow(L,2)*(M0 - M1)*(MM0 - MM1)*Math.pow(sec,2)))/(6.*Math.pow(H,2)); break;
            case 3: val=(coef*L*(M0*(2*MM0 + MM1) + M1*(MM0 + 2*MM1))*sec)/6.; break;
            case 4: val=-((-1 + coef)*L*(M0*(2*MM0 + MM1) + M1*(MM0 + 2*MM1))*sec)/6.; break;
            case 5: val=(H*M0*MM0)/3. + (H*M1*MM0)/6. + (H*M0*MM1)/6. + (H*M1*MM1)/3.; break;
        }
        val=val/(this.theMaterial.getElast()*this.theSection.getI());
        return val;
    }
}
