/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package core;

import Jama.LUDecomposition;
import Jama.Matrix;
import Jama.SingularValueDecomposition;
import gui.myTextArea;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author pchr
 */
public class structure {
    private member[] themembers;
    private double angle;
    private double H;
    private double L;
    
    private double Hd,yd,xd; // for H', x', y'
    
    private boolean YieldAnalysis=false;
    private boolean AxialInfluence=true;
    private double coef;
    
    private Map<Integer,state> theStates = new HashMap<Integer,state>();
    
    public structure(){};
    
    public structure(double angle, double H, double L, double coef){
        state Astate = new state(); Astate.setZeroStates();
        point Apoint = new point(); Apoint.setZeroPoints();
        material Amaterial = new material(); Amaterial.setZeroMaterials();
        themembers = new member[5];
        this.angle=angle;
        this.H=H;
        this.L=L;
        this.coef=coef;
        
        this.Hd=L*Math.tan(angle);
        this.yd=coef*Hd;
        this.xd=coef*L;
    }
    
    public member[] getMembers(){
        return this.themembers;
    }
    
    
    public void addMember(int id, section Asection, material Amaterial){
        if(id<=5 && id>0){
            point P1=new point();
            point P2=new point();
            String theName="00";
            double Mp=Asection.getWp()*Amaterial.getYieldStress();
            switch(id){
                case 1: P1=new point(2.*L,0.); P2=new point(2.*L,H); theName="ΒΕ";break;
                case 2: P1=new point(2.*L,H); P2=new point(L,H+L*Math.tan(angle)); theName="ΕΔ";break;
                case 3: P1=new point(L,H+L*Math.tan(angle)); P2=new point(L-coef*L,H+(1.-coef)*L*Math.tan(angle)); theName="ΔΖ"; break;
                case 4: P1=new point(L-coef*L,H+(1.-coef)*L*Math.tan(angle)); P2=new point(0.,H); theName="ΖΓ";break;
                case 5: P1=new point(0.,H); P2=new point(0.,0.); theName="ΓΑ";break;
            }
            P1.setMoment(Mp); P2.setMoment(Mp);
            member Amember=new member(id, P1, P2, Amaterial, Asection,theName);
            Amember.setStructure(this);
            if(id==1){Amember.getP1().hingethis();}
            themembers[id-1]=Amember;
        }
    }
    
    /*public void addMember(int id, section Asection, material Amaterial,point P1, point P2){
        if(id<=5 && id>0){
            double Mp=Asection.getWp()*Amaterial.getYieldStress();
            P1.setMoment(Mp); P2.setMoment(Mp);
            member Amember=new member(id, P1, P2, Amaterial, Asection);
            Amember.setStructure(this);
            if(id==1){Amember.getP1().hingethis();}
            themembers[id-1]=Amember;
        }
    }*/

    public double getAngle(){
        return this.angle;
    }
    
    public double getH(){
        return this.H;
    }
    
    public double getL(){
        return this.L;
    }

    
    public double getCoef(){
        return this.coef;
    }
    
    public void solve1(){
        //System.out.println("--------------------------------------------------------------");
        //System.out.println("--------------------      in solve 1     ---------------------");
        double theSign=this.theStates.get(1).getSignum();
        Matrix theMatrix;
        Matrix theVector;
        Matrix theSolution;
        LUDecomposition LUofA;
        theMatrix = new Matrix(3,3); theMatrix.init();
        theVector = new Matrix(3,1); theVector.init();
        theSolution = new Matrix(3,1); theVector.init();
        
        //======================================================================
        double x1=this.theStates.get(1).getX1();
        double x2=this.theStates.get(1).getX2();
        double p=this.theStates.get(1).getP();
        int mem=this.theStates.get(1).getWhichMemberId();
        int mp=this.theStates.get(1).getWhichPoint();
        double lx=0.;
        switch(mp){
            case 0: lx=0.; break;
            case 1: lx=themembers[mem-1].getL(); break;
        }
        double My1=this.themembers[mem-1].getM(lx, x1, x2, p);
        double prSign=Math.signum(My1);
        //======================================================================
        
        for(int i=0;i<5;i++){
            theMatrix.addVal(0, 0, this.themembers[i].getM1()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM1()[1]); theMatrix.addVal(0, 2, this.themembers[i].getM1()[2]);
            theMatrix.addVal(1, 0, this.themembers[i].getM2()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2()[1]); theMatrix.addVal(1, 2, this.themembers[i].getM2()[2]);
        }
        
        double minP=20.0e20;
        double x1_temp,x2_temp;
        int wPoint,wMember; wMember=1; wPoint=1;
        x2_temp=0.;x1_temp=0.;
        for(int i=0;i<5;i++){
            if(!themembers[i].getP1().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]);
                theVector.set(2, 0, prSign*themembers[i].getP1().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP1().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "START");
                if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=0;
                    wMember=themembers[i].getId();
                }
            }
            //this.P=1.;
            if(!themembers[i].getP2().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]);
                theVector.set(2, 0, prSign*themembers[i].getP2().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP2().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "END");
                if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=1;
                    wMember=themembers[i].getId();
                }
            }
            
        }
        this.themembers[wMember-1].getPoint(wPoint).hingethis();
        switch(wPoint){
            case 0: if(this.themembers[wMember-1].getId()!=1){
                this.themembers[wMember-2].getPoint(1).hingethis();
            } 
            break;
            case 1: if(this.themembers[wMember-1].getId()!=5){
                this.themembers[wMember].getPoint(0).hingethis();
            } 
            break;
        }
        double dg=this.getDeltaG(x1_temp, x2_temp, minP);
        state Astate = new state(false, true, wMember, wPoint, minP, x1_temp, x2_temp, 1,dg);
        Astate.printState();
        this.theStates.put(Astate.getId(), Astate);
    }
    
    public void solve2(){
        double theSign=this.theStates.get(1).getSignum();
        double x1=this.theStates.get(2).getX1();
        double x2=this.theStates.get(2).getX2();
        double p=this.theStates.get(2).getP();
        int mem=this.theStates.get(2).getWhichMemberId();
        int mp=this.theStates.get(2).getWhichPoint();
        double lx=0.;
        switch(mp){
            case 0: lx=0.; break;
            case 1: lx=themembers[mem-1].getL(); break;
        }
        double Mp1=this.themembers[mem-1].getM(lx, x1, x2, p);
        int GlobalPointID=this.themembers[mem-1].getPoint(mp).getId();
        
        Matrix theMatrix;
        Matrix theVector;
        Matrix theSolution;
        LUDecomposition LUofA;
        theMatrix = new Matrix(3,3); theMatrix.init();
        theVector = new Matrix(3,1); theVector.init();
        theSolution = new Matrix(3,1); theVector.init();
        
        double Py1=Math.abs(this.theStates.get(2).getP());
        
        switch(GlobalPointID){
            case 2:
            case 3:
                //solve2_E();
                for(int i=0;i<5;i++){
                    theMatrix.addVal(0, 0, this.themembers[i].getM1()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM1()[1]); theMatrix.addVal(0, 2, this.themembers[i].getM1()[2]);
                }
                theMatrix.set(1, 1, -H);  theVector.set(1, 0, Mp1);
                break;
            case 4:
            case 5:
                //solve2_D();
                for(int i=0;i<5;i++){
                    theMatrix.addVal(0, 0, this.themembers[i].getM2_D()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM2_D()[1]); theMatrix.addVal(0, 2, this.themembers[i].getM2_D()[2]);
                }
                theMatrix.set(1, 0, L); theMatrix.set(1, 1, -(H+Hd)); theMatrix.set(1, 2, -L/2.); theVector.set(1, 0, Mp1);
                break;
            case 6:
            case 7:
                //solve2_Z();
                for(int i=0;i<5;i++){
                    theMatrix.addVal(0, 0, this.themembers[i].getM2_Z()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM2_Z()[1]); theMatrix.addVal(0, 2, this.themembers[i].getM2_Z()[2]);
                }
                theMatrix.set(1, 0, L+xd); theMatrix.set(1, 1, -(H+Hd-yd)); theMatrix.set(1, 2, -(L/2.+xd)); theVector.set(1, 0, Mp1);
                break;
            case 8:
            case 9:
                //solve2_G();
                for(int i=0;i<5;i++){
                    theMatrix.addVal(0, 0, this.themembers[i].getM2_G()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM2_G()[1]); theMatrix.addVal(0, 2, this.themembers[i].getM2_G()[2]);
                }
                theMatrix.set(1, 0, 2*L); theMatrix.set(1, 1, -H); theMatrix.set(1, 2, -(3.*L/2.+Hd-yd)); theVector.set(1, 0, Mp1);
                break;
            case 10:
                //solve2_A(); 
                for(int i=0;i<5;i++){
                    theMatrix.addVal(0, 0, this.themembers[i].getM2()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM2()[1]); theMatrix.addVal(0, 2, this.themembers[i].getM2()[2]);
                }
                theMatrix.set(1, 0, 2.*L); theMatrix.set(1, 2, -(L/2.+L+H+Hd-yd)); theVector.set(1, 0, Mp1);
                break;
        }
        double minP=20.0e20;
        double x1_temp,x2_temp;
        int wPoint,wMember; wMember=1; wPoint=1;
        x2_temp=0.;x1_temp=0.;
        for(int i=0;i<5;i++){
            // sto P1 me thetiki ropi
            if(!themembers[i].getP1().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]);
                theVector.set(2, 0, themembers[i].getP1().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP1().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "START");
                if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=0;
                    wMember=themembers[i].getId();
                }
            }
            // sto P1 me arnitiki ropi
            if(!themembers[i].getP1().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]);
                theVector.set(2, 0, -themembers[i].getP1().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP1().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "START");
                if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=0;
                    wMember=themembers[i].getId();
                }
            }
            //this.P=1.;
            // sto P2 me thetiki ropi
            if(!themembers[i].getP2().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]);
                theVector.set(2, 0, themembers[i].getP2().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP2().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "END");
                if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=1;
                    wMember=themembers[i].getId();
                }
            }
            // sto P2 me arnitki ropi
            if(!themembers[i].getP2().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]);
                theVector.set(2, 0, -themembers[i].getP2().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP2().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "END");
                if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=1;
                    wMember=themembers[i].getId();
                }
            }
            
        }
        this.themembers[wMember-1].getPoint(wPoint).hingethis();
        switch(wPoint){
            case 0: if(this.themembers[wMember-1].getId()!=1){
                this.themembers[wMember-2].getPoint(1).hingethis();
            } 
            break;
            case 1: if(this.themembers[wMember-1].getId()!=5){
                this.themembers[wMember].getPoint(0).hingethis();
            } 
            break;
        }
        double dg=this.getDeltaG(x1_temp, x2_temp, minP);
        state Astate = new state(false, true, wMember, wPoint, minP, x1_temp, x2_temp, 1,dg);
        Astate.printState();
        this.theStates.put(Astate.getId(), Astate);
        
        
        
        //// xana
        int flag=0;
        for(int i=0;i<5;i++){
            // sto P1 me thetiki ropi
            if(!themembers[i].getP1().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]);
                theVector.set(2, 0, themembers[i].getP1().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP1().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "START");
                if(Math.abs(theSolution.get(2, 0)-minP)<=Math.abs(minP)*1.e-5 && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=0;
                    wMember=themembers[i].getId();
                    flag=1;
                }
            }
            // sto P1 me arnitiki ropi
            if(!themembers[i].getP1().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]);
                theVector.set(2, 0, -themembers[i].getP1().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP1().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "START");
                if(Math.abs(theSolution.get(2, 0)-minP)<=Math.abs(minP)*1.e-5 && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=0;
                    wMember=themembers[i].getId();
                    flag=1;
                }
            }
            //this.P=1.;
            // sto P2 me thetiki ropi
            if(!themembers[i].getP2().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]);
                theVector.set(2, 0, themembers[i].getP2().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP2().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "END");
                if(Math.abs(theSolution.get(2, 0)-minP)<=Math.abs(minP)*1.e-5 && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=1;
                    wMember=themembers[i].getId();
                    flag=1;
                }
            }
            // sto P2 me arnitki ropi
            if(!themembers[i].getP2().hinged()){
                theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]);
                theVector.set(2, 0, -themembers[i].getP2().getMoment());
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                themembers[i].getP2().setPy1(theSolution.get(2, 0));
                //printSys(theMatrix, theVector, theSolution, i, "END");
                if(Math.abs(theSolution.get(2, 0)-minP)<=Math.abs(minP)*1.e-5 && Math.abs(theSolution.get(2, 0))>=Py1 && Math.signum(theSolution.get(2, 0))==theSign){
                    minP=theSolution.get(2, 0);
                    x1_temp=theSolution.get(0, 0);
                    x2_temp=theSolution.get(1, 0);
                    wPoint=1;
                    wMember=themembers[i].getId();
                    flag=1;
                }
            }
            
        }
        //System.out.println("flag= "+flag);
        if(flag==1){
            this.themembers[wMember-1].getPoint(wPoint).hingethis();
            switch(wPoint){
                case 0: if(this.themembers[wMember-1].getId()!=1){
                    this.themembers[wMember-2].getPoint(1).hingethis();
                } 
                break;
                case 1: if(this.themembers[wMember-1].getId()!=5){
                    this.themembers[wMember].getPoint(0).hingethis();
                } 
                break;
            }
            //dg=this.getDeltaG(x1_temp, x2_temp, minP);
            Astate = new state(false, true, wMember, wPoint, minP, x1_temp, x2_temp, 1,dg);
            Astate.printState();
            this.theStates.put(Astate.getId(), Astate);
        }
    }
    
    public void solve3(){
        if(this.theStates.size()<4){
            double theSign=this.theStates.get(1).getSignum();
            double x1=this.theStates.get(2).getX1();
            double x2=this.theStates.get(2).getX2();
            double p=this.theStates.get(2).getP();
            int mem1=this.theStates.get(2).getWhichMemberId();
            int p1=this.theStates.get(2).getWhichPoint();
            double Mp1=0.;
            switch(p1){
                case 0: Mp1=this.themembers[mem1-1].getM(0., x1, x2, p); break;
                case 1: Mp1=this.themembers[mem1-1].getM(themembers[mem1-1].getL(), x1, x2, p); break;
            }
            x1=this.theStates.get(3).getX1();
            x2=this.theStates.get(3).getX2();
            p=this.theStates.get(3).getP();
            int mem2=this.theStates.get(3).getWhichMemberId();
            int p2=this.theStates.get(3).getWhichPoint();
            double Mp2=0.;
            switch(p2){
                case 0: Mp2=this.themembers[mem2-1].getM(0., x1, x2, p); break;
                case 1: Mp2=this.themembers[mem2-1].getM(themembers[mem2-1].getL(), x1, x2, p); break;
            }

            Matrix IS = new Matrix(3,3); IS.init();
            Matrix theMatrix = new Matrix(3,3); theMatrix.init();
            Matrix theVector = new Matrix(3,1); theVector.init();
            Matrix theSolution = new Matrix(3,1); IS.init();
            SingularValueDecomposition SVDofA ;

            double dp1 = 0;
            double dp2 = 0;
            switch(p1){
                case 0: dp1=0.; break;
                case 1: dp1=1.; break;
            }
            switch(p2){
                case 0: dp2=0.; break;
                case 1: dp2=1.; break;
            }

            theMatrix.set(0, 0, this.themembers[mem1-1].getMcoefs(dp1)[0]); theMatrix.set(0, 1, this.themembers[mem1-1].getMcoefs(dp1)[1]); theMatrix.set(0, 2, this.themembers[mem1-1].getMcoefs(dp1)[2]);
            theVector.set(0, 0, Mp1);
            theMatrix.set(1, 0, this.themembers[mem2-1].getMcoefs(dp2)[0]); theMatrix.set(1, 1, this.themembers[mem2-1].getMcoefs(dp2)[1]); theMatrix.set(1, 2, this.themembers[mem2-1].getMcoefs(dp2)[2]);
            theVector.set(1, 0, Mp2);

            double minP=20.0e20;
            double x1_temp,x2_temp;
            int wPoint,wMember; wMember=1; wPoint=1;
            x2_temp=0.;x1_temp=0.;

            double Py2=Math.abs(this.theStates.get(3).getP());

            for(int i=0;i<5;i++){
                // sto P1 me thetiki ropi
                if(!themembers[i].getP1().hinged()){
                    theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]);
                    theVector.set(2, 0, themembers[i].getP1().getMoment());
                    IS.init();
                    SVDofA = new SingularValueDecomposition(theMatrix);
                    for(int ii=0;ii<SVDofA.getS().getColumnDimension();ii++){
                        if(Math.abs(SVDofA.getS().get(ii, ii))>1.E-20)IS.set(ii, ii, 1./SVDofA.getS().get(ii, ii));
                    }
                    theSolution=SVDofA.getV().times(IS).times(SVDofA.getU().transpose()).times(theVector);
                    //printSys(theMatrix, theVector, theSolution, i, "START +");
                    if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py2  && Math.signum(theSolution.get(2, 0))==theSign){
                        minP=theSolution.get(2, 0);
                        x1_temp=theSolution.get(0, 0);
                        x2_temp=theSolution.get(1, 0);
                        wPoint=0;
                        wMember=themembers[i].getId();
                    }
                }
                // sto P1 me arnitiki ropi
                if(!themembers[i].getP1().hinged()){
                    theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]);
                    theVector.set(2, 0, -themembers[i].getP1().getMoment());
                    IS.init();
                    SVDofA = new SingularValueDecomposition(theMatrix);
                    for(int ii=0;ii<SVDofA.getS().getColumnDimension();ii++){
                        if(Math.abs(SVDofA.getS().get(ii, ii))>1.E-20)IS.set(ii, ii, 1./SVDofA.getS().get(ii, ii));
                    }
                    theSolution=SVDofA.getV().times(IS).times(SVDofA.getU().transpose()).times(theVector);
                    //printSys(theMatrix, theVector, theSolution, i, "START -");
                    if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py2  && Math.signum(theSolution.get(2, 0))==theSign){
                        minP=theSolution.get(2, 0);
                        x1_temp=theSolution.get(0, 0);
                        x2_temp=theSolution.get(1, 0);
                        wPoint=0;
                        wMember=themembers[i].getId();
                    }
                }
                // sto P2 me thetiki ropi
                if(!themembers[i].getP2().hinged()){
                    theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]);
                    theVector.set(2, 0, themembers[i].getP2().getMoment());
                    IS.init();
                    SVDofA = new SingularValueDecomposition(theMatrix);
                    for(int ii=0;ii<SVDofA.getS().getColumnDimension();ii++){
                        if(Math.abs(SVDofA.getS().get(ii, ii))>1.E-20)IS.set(ii, ii, 1./SVDofA.getS().get(ii, ii));
                    }
                    theSolution=SVDofA.getV().times(IS).times(SVDofA.getU().transpose()).times(theVector);
                    //printSys(theMatrix, theVector, theSolution, i, "END +");
                    if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py2  && Math.signum(theSolution.get(2, 0))==theSign){
                        minP=theSolution.get(2, 0);
                        x1_temp=theSolution.get(0, 0);
                        x2_temp=theSolution.get(1, 0);
                        wPoint=1;
                        wMember=themembers[i].getId();
                    }
                }
                // sto P2 me arnitiki ropi
                if(!themembers[i].getP2().hinged()){
                    theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]); theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]); theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]);
                    theVector.set(2, 0, -themembers[i].getP2().getMoment());
                    IS.init();
                    SVDofA = new SingularValueDecomposition(theMatrix);
                    for(int ii=0;ii<SVDofA.getS().getColumnDimension();ii++){
                        if(Math.abs(SVDofA.getS().get(ii, ii))>1.E-20)IS.set(ii, ii, 1./SVDofA.getS().get(ii, ii));
                    }
                    theSolution=SVDofA.getV().times(IS).times(SVDofA.getU().transpose()).times(theVector);
                    //printSys(theMatrix, theVector, theSolution, i, "END -");
                    if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && Math.abs(theSolution.get(2, 0))>=Py2  && Math.signum(theSolution.get(2, 0))==theSign){
                        minP=theSolution.get(2, 0);
                        x1_temp=theSolution.get(0, 0);
                        x2_temp=theSolution.get(1, 0);
                        wPoint=1;
                        wMember=themembers[i].getId();
                    }
                }
            }
            double dg=this.getDeltaG(x1_temp, x2_temp, minP);
            state Astate = new state(false, true, wMember, wPoint, minP, x1_temp, x2_temp, 1,dg);
            Astate.printState();
            this.theStates.put(Astate.getId(), Astate);
        }
    }
    
    public void solveY_N(myTextArea outext){
        //System.out.println("--------------------------------------------------------------");
        //System.out.println("--------------------      in solve y     ---------------------");
        YieldAnalysis=true;
        Matrix theMatrix;
        Matrix theVector;
        Matrix theSolution;
        LUDecomposition LUofA;
        theMatrix = new Matrix(3,3); theMatrix.init();
        theVector = new Matrix(3,1); theVector.init();
        theSolution = new Matrix(3,1); theVector.init();
        
        for(int i=0;i<5;i++){
            theMatrix.addVal(0, 0, this.themembers[i].getM1()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM1()[1]); theMatrix.addVal(0, 2, this.themembers[i].getM1()[2]);
            theMatrix.addVal(1, 0, this.themembers[i].getM2()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2()[1]); theMatrix.addVal(1, 2, this.themembers[i].getM2()[2]);
            
            //System.out.println("d1 "+i+1+" "+this.themembers[i].getM1()[0]+" "+this.themembers[i].getM1()[1]+" "+this.themembers[i].getM1()[2]);
            //System.out.println("d2 "+i+1+" "+this.themembers[i].getM2()[0]+" "+this.themembers[i].getM2()[1]+" "+this.themembers[i].getM2()[2]);
        }
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.00000",comma);
        outext.append('\n'+"σύστημα εξισώσεων για την εύρεση των Χ1, Χ2"+'\n');
        outext.append("περίπτωση πρώτης διαρροής, έκφραση ως συντελεστών του P"+'\n');
        char sgn='+';
        if(Math.signum(theMatrix.get(0, 1))==-1.){sgn='-';}
        outext.append(Places.format(theMatrix.get(0, 0))+"*X1"+sgn+Places.format(Math.abs(theMatrix.get(0, 1)))+"*X2 = "+Places.format(-theMatrix.get(0, 2))+'\n');
        sgn='+';
        if(Math.signum(theMatrix.get(1, 1))==-1.){sgn='-';}
        outext.append(Places.format(theMatrix.get(1, 0))+"*X1"+sgn+Places.format(theMatrix.get(1, 1))+"*X2 = "+Places.format(-theMatrix.get(1, 2))+'\n');
        double minP=20.0e20;
        double x1_temp,x2_temp;
        int wPoint,wMember; wMember=1; wPoint=1;
        x2_temp=0.;x1_temp=0.;
        for(int i=0;i<5;i++){
            // P1 M+N

            if(!this.themembers[i].getP1().hinged()){
            theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(0.)[0]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(0.)[1]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(0.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "START M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=0;
                wMember=themembers[i].getId();
            }}

            // P1 -M+N

            if(!this.themembers[i].getP1().hinged()){
            theMatrix.set(2, 0, -this.themembers[i].getMcoefs(0.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, -this.themembers[i].getMcoefs(0.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, -this.themembers[i].getMcoefs(0.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(0.)[0]/this.themembers[i].getSection().getA());
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(0.)[1]/this.themembers[i].getSection().getA());
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(0.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "START -M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=0;
                wMember=themembers[i].getId();
            }}
                
            // P2 M+N

            theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(1.)[0]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(1.)[1]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(1.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "END M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=1;
                wMember=themembers[i].getId();
            }

            // P2 -M+N

            theMatrix.set(2, 0, -this.themembers[i].getMcoefs(1.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, -this.themembers[i].getMcoefs(1.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, -this.themembers[i].getMcoefs(1.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(1.)[0]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(1.)[1]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(1.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "END -M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=1;
                wMember=themembers[i].getId();
            }
            
            
            /////// me arntitki sy
            // P1 M+N

            if(!this.themembers[i].getP1().hinged()){
            theMatrix.set(2, 0, this.themembers[i].getMcoefs(0.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, this.themembers[i].getMcoefs(0.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, this.themembers[i].getMcoefs(0.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(0.)[0]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(0.)[1]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(0.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, -themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "START M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=0;
                wMember=themembers[i].getId();
            }}

            // P1 -M+N

            if(!this.themembers[i].getP1().hinged()){
            theMatrix.set(2, 0, -this.themembers[i].getMcoefs(0.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, -this.themembers[i].getMcoefs(0.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, -this.themembers[i].getMcoefs(0.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(0.)[0]/this.themembers[i].getSection().getA());
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(0.)[1]/this.themembers[i].getSection().getA());
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(0.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, -themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "START -M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=0;
                wMember=themembers[i].getId();
            }}
                
            // P2 M+N

            theMatrix.set(2, 0, this.themembers[i].getMcoefs(1.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, this.themembers[i].getMcoefs(1.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, this.themembers[i].getMcoefs(1.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(1.)[0]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(1.)[1]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(1.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, -themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "END M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=1;
                wMember=themembers[i].getId();
            }

            // P2 -M+N

            theMatrix.set(2, 0, -this.themembers[i].getMcoefs(1.)[0]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 1, -this.themembers[i].getMcoefs(1.)[1]/this.themembers[i].getSection().getWy()); 
            theMatrix.set(2, 2, -this.themembers[i].getMcoefs(1.)[2]/this.themembers[i].getSection().getWy());
            if(AxialInfluence){
                theMatrix.addVal(2, 0, this.themembers[i].getNcoefs(1.)[0]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 1, this.themembers[i].getNcoefs(1.)[1]/this.themembers[i].getSection().getA()); 
                theMatrix.addVal(2, 2, this.themembers[i].getNcoefs(1.)[2]/this.themembers[i].getSection().getA());
            }
            theVector.set(2, 0, -themembers[i].getMaterial().getYieldStress());
            LUofA = new LUDecomposition(theMatrix);
            theSolution=LUofA.solve(theVector);
            //printSys(theMatrix, theVector, theSolution, i, "END -M+N");
            if(Math.abs(theSolution.get(2, 0))<Math.abs(minP) && theSolution.get(2, 0)>0.0){
                minP=theSolution.get(2, 0);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                wPoint=1;
                wMember=themembers[i].getId();
            }

        }
        double dg=this.getDeltaG(x1_temp, x2_temp, minP);
        state Astate = new state(true, false, wMember, wPoint, minP, x1_temp, x2_temp, 1,dg);
        Astate.setSignum(minP);
        Astate.printState();
        this.theStates.put(Astate.getId(), Astate);
    }
    
    public double getDeltaG(double x1, double x2, double p){
        double val=0.;
        int flag = 0;
        double P2 = 0;
        double P3 = 0;
        double dP;
        
        double x1_temp=0.;
        double x2_temp=0.;
        Matrix theMatrix = new Matrix(2,2); theMatrix.init();
        Matrix theVector = new Matrix(2,1); theVector.init();
        Matrix theSolution = new Matrix(2,1); theSolution.init();
        
        switch(theStates.size()){
            case 0:
            case 1:
                flag=0;
                break;
            case 2:
                flag=1;
                break;
            case 3:
                flag=2;
                break;
            default:
                P2=theStates.get(2).getP();
                P3=theStates.get(3).getP();
                if(p<=P2){flag=0;}
                if(p>P2 && p<=P3){flag=1;}
                if(p>P3){flag=2;}
                break;
        }
        
        switch(flag){
            case 0:
                double sin=Math.sin(angle);
                double cos=Math.cos(angle);
                val=-H*H*L*x1+H*H*H*x2/6.+H*H*(4.*H+9.*L-6.*(coef-1.)*L*sin/cos)*p/12.;
                val=val/(this.themembers[4].getMaterial().getElast()*this.themembers[4].getSection().getI());
                break;
            case 1:
                P2=theStates.get(2).getP();
                dP=p-P2;
                int mem=this.theStates.get(2).getWhichMemberId();
                int mp=this.theStates.get(2).getWhichPoint();
                int global1=this.themembers[mem-1].getPoint(mp).getId();
                double M1,M0;
                
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(0, 1, H); theVector.set(0, 0, 0.);
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM1()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM1()[1]); theVector.addVal(1, 0, -this.themembers[i].getM1()[2]*dP);
                        }
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(0, 0, L); theMatrix.set(0, 1, -(H+Hd)); theVector.set(0, 0, dP*L/2.);
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2_D()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2_D()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2_D()[2]*dP);
                        }
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(0, 0, L+xd); theMatrix.set(0, 1, -(H+Hd-yd)); theVector.set(0, 0, dP*(L/2.+xd));
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2_Z()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2_Z()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2_Z()[2]*dP);
                        }
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(0, 0, 2.*L); theMatrix.set(0, 1, -(H)); theVector.set(0, 0, dP*(3.*L/2.)+dP*(Hd-yd));
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2_G()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2_G()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2_G()[2]*dP);
                        }
                        break;
                    case 10:
                        theMatrix.set(0, 0, 2.*L); theVector.set(0, 0, dP*(3.*L/2.)+dP*(H+Hd-yd));
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2()[2]*dP);
                        }
                        break;
                }
                LUDecomposition LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                
                theMatrix.init();
                theVector.init();
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(0, 1, H); theVector.set(0, 0, 0.);
                        theMatrix.set(1, 0, 2.*L); theVector.set(1, 0, -H);
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(0, 0, L); theMatrix.set(0, 1, -(H+Hd)); theVector.set(0, 0, 0.);
                        theMatrix.set(1, 0, 2.*L); theVector.set(1, 0, -H);
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(0, 0, L+xd); theMatrix.set(0, 1, -(H+Hd-yd)); theVector.set(0, 0, 0.);
                        theMatrix.set(1, 0, 2.*L); theVector.set(1, 0, -H);
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(0, 0, 2.*L); theMatrix.set(0, 1, -(H)); theVector.set(0, 0, 0.);
                        theMatrix.set(1, 0, 2.*L); theVector.set(1, 0, -H);
                        break;
                    case 10:
                        theMatrix.set(0, 0, 2.*L); theVector.set(0, 0, -H);
                        theMatrix.set(1, 0, L); theMatrix.set(1, 1, -(H+Hd)); theVector.set(1, 0, 0.);
                        break;
                }
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                x1=theSolution.get(0, 0);
                x2=theSolution.get(1, 0);
                val=0.;
                for(int i=0;i<5;i++){
                    M0=themembers[i].getM_isostatic(0., x1, x2, 1.);
                    M1=themembers[i].getM_isostatic(themembers[i].getL(), x1, x2, 1.);
                    val+=themembers[i].getM_mult(x1_temp, x2_temp, dP, M0, M1);
                }
                val=Math.signum(val)*val+this.theStates.get(2).getDeltaG();
                break;
            case 2:
                P2=theStates.get(2).getP();
                P3=theStates.get(3).getP();
                dP=p-P3;
                mem=this.theStates.get(2).getWhichMemberId();
                mp=this.theStates.get(2).getWhichPoint();
                global1=this.themembers[mem-1].getPoint(mp).getId();
                
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(0, 1, H); theVector.set(0, 0, 0.);
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(0, 0, L); theMatrix.set(0, 1, -(H+Hd)); theVector.set(0, 0, dP*L/2.);
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(0, 0, L+xd); theMatrix.set(0, 1, -(H+Hd-yd)); theVector.set(0, 0, dP*(L/2.+xd));
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(0, 0, 2.*L); theMatrix.set(0, 1, -(H)); theVector.set(0, 0, dP*(3.*L/2.)+dP*(Hd-yd));
                        break;
                    case 10:
                        theMatrix.set(0, 0, 2.*L); theVector.set(0, 0, dP*(3.*L/2.)+dP*(H+Hd-yd));
                        break;
                }
                mem=this.theStates.get(3).getWhichMemberId();
                mp=this.theStates.get(3).getWhichPoint();
                global1=this.themembers[mem-1].getPoint(mp).getId();
                
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(1, 1, H); theVector.set(1, 0, 0.);
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(1, 0, L); theMatrix.set(1, 1, -(H+Hd)); theVector.set(1, 0, dP*L/2.);
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(1, 0, L+xd); theMatrix.set(1, 1, -(H+Hd-yd)); theVector.set(1, 0, dP*(L/2.+xd));
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(1, 0, 2.*L); theMatrix.set(1, 1, -(H)); theVector.set(1, 0, dP*(3.*L/2.)+dP*(Hd-yd));
                        break;
                    case 10:
                        theMatrix.set(1, 0, 2.*L); theVector.set(1, 0, dP*(3.*L/2.)+dP*(H+Hd-yd));
                        break;
                }
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                
                mem=this.theStates.get(2).getWhichMemberId();
                mp=this.theStates.get(2).getWhichPoint();
                global1=this.themembers[mem-1].getPoint(mp).getId();
                
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(0, 1, H); theVector.set(0, 0, 0.);
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(0, 0, L); theMatrix.set(0, 1, -(H+Hd)); theVector.set(0, 0, 0.);
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(0, 0, L+xd); theMatrix.set(0, 1, -(H+Hd-yd)); theVector.set(0, 0, 0.);
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(0, 0, 2.*L); theMatrix.set(0, 1, -(H)); theVector.set(0, 0, 0.);
                        break;
                    case 10:
                        theMatrix.set(0, 0, 2.*L); theVector.set(0, 0, -H);
                        break;
                }
                mem=this.theStates.get(3).getWhichMemberId();
                mp=this.theStates.get(3).getWhichPoint();
                global1=this.themembers[mem-1].getPoint(mp).getId();
                
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(1, 1, H); theVector.set(1, 0, 0.);
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(1, 0, L); theMatrix.set(1, 1, -(H+Hd)); theVector.set(1, 0, 0.);
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(1, 0, L+xd); theMatrix.set(1, 1, -(H+Hd-yd)); theVector.set(1, 0, 0.);
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(1, 0, 2.*L); theMatrix.set(1, 1, -(H)); theVector.set(1, 0, 0.);
                        break;
                    case 10:
                        theMatrix.set(1, 0, 2.*L); theVector.set(1, 0, -H);
                        break;
                }
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                x1=theSolution.get(0, 0);
                x2=theSolution.get(1, 0);
                
                
                val=0.;
                double MM0,MM1;
                for(int i=0;i<5;i++){
                    M0=themembers[i].getM_isostatic(0., x1_temp, x2_temp, 1.);
                    M1=themembers[i].getM_isostatic(themembers[i].getL(), x1_temp, x2_temp, 1.);
                    MM0=themembers[i].getM_isostatic(0., x1, x2, 1.);
                    MM1=themembers[i].getM_isostatic(themembers[i].getL(), x1, x2, 1.);
                    val-=themembers[i].getM_mult_iso(M0, M1, MM0, MM1);
                }
                val+=this.theStates.get(3).getDeltaG();
                break;
        }
        return val;
    }
    
    private void printSys(Matrix theMatrix, Matrix theVector, Matrix theSolution, int i, String thePoint){
        System.out.println("===================================");
            System.out.print("Member "+i+" "+thePoint);
            theMatrix.print(20, 10);
            theVector.print(20, 10);
            theSolution.print(20, 10);
    }
    
    public Map<Integer,state> getStates(){
        return this.theStates;
    }
    
    public void setAxialInfluence(boolean that){
        this.AxialInfluence=that;
    }
    
    public void addState(state Astate){
        theStates.put(Astate.getId(), Astate);
    }
    
    public void printM(state Astate, myTextArea Tarea){
        double x1=Astate.getX1();
        double x2=Astate.getX2();
        double p=Astate.getP();
        double len;
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.000",comma);
        String m1,m2;
        m1=Places.format(Astate.getP());
        Tarea.append('\n'+"κατάσταση: "+Astate.getId()+", P="+m1+'\n');
        Tarea.append("ροπές αρχής και τέλους μελών"+'\n');
        for(int i=0;i<this.getMembers().length; i++){
            len=this.getMembers()[i].getL();
            m1=Places.format(this.getMembers()[i].getM(0.,x1,x2,p));
            m2=Places.format(this.getMembers()[i].getM(len,x1,x2,p));
            Tarea.append("μέλος :"+this.getMembers()[i].getName()+" "+m1+" "+m2+'\n');
        }
    }
    
    public void printN(state Astate, myTextArea Tarea){
        double x1=Astate.getX1();
        double x2=Astate.getX2();
        double p=Astate.getP();
        double len;
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.000",comma);
        String m1,m2;
        m1=Places.format(Astate.getP());
        Tarea.append('\n'+"κατάσταση: "+Astate.getId()+", P="+m1+'\n');
        Tarea.append("αξονικές δυνάμεις αρχής και τέλους μελών"+'\n');
        for(int i=0;i<this.getMembers().length; i++){
            len=this.getMembers()[i].getL();
            m1=Places.format(this.getMembers()[i].getN(0.,x1,x2,p));
            m2=Places.format(this.getMembers()[i].getN(len,x1,x2,p));
            Tarea.append("μέλος :"+this.getMembers()[i].getName()+" "+m1+" "+m2+'\n');
        }
    }
    
    public void printQ(state Astate, myTextArea Tarea){
        double x1=Astate.getX1();
        double x2=Astate.getX2();
        double p=Astate.getP();
        double len;
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.000",comma);
        String m1,m2;
        m1=Places.format(Astate.getP());
        Tarea.append('\n'+"κατάσταση: "+Astate.getId()+", P="+m1+'\n');
        Tarea.append("τέμνουσες δυνάμεις αρχής και τέλους μελών"+'\n');
        for(int i=0;i<this.getMembers().length; i++){
            len=this.getMembers()[i].getL();
            m1=Places.format(this.getMembers()[i].getQ(0.,x1,x2,p));
            m2=Places.format(this.getMembers()[i].getQ(len,x1,x2,p));
            Tarea.append("μέλος :"+this.getMembers()[i].getName()+" "+m1+" "+m2+'\n');
        }
    }
    
    public void SolveForP(double Pval, int Case,myTextArea Tarea){
        Matrix theMatrix;
        Matrix theVector;
        Matrix theSolution;
        state Astate;
        LUDecomposition LUofA ;
        int stId;
        double dg;
        double x1_temp=0.;
        double x2_temp=0.;
        theMatrix = new Matrix(2,2); theMatrix.init();
        theVector = new Matrix(2,1); theVector.init();
        theSolution = new Matrix(2,1); theVector.init();
        
        double x1;
        double x2;
        double p;
        int mem;
        int mp;
        int global1;
        int global2;
        double lx;
        
        switch(Case){
            case 1:
                for(int i=0;i<5;i++){
                    theMatrix.addVal(0, 0, this.themembers[i].getM1()[0]); theMatrix.addVal(0, 1, this.themembers[i].getM1()[1]); theVector.addVal(0, 0, -this.themembers[i].getM1()[2]*Pval);
                    theMatrix.addVal(1, 0, this.themembers[i].getM2()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2()[2]*Pval);
                }
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                //printSys(theMatrix, theVector, theSolution, 0, "none");
                dg=this.getDeltaG(x1_temp, x2_temp, Pval);
                Astate = new state(false, false, 0, 2, Pval, x1_temp, x2_temp, 1,dg);
                this.theStates.put(Astate.getId(), Astate);
                printM(Astate,Tarea);
                printN(Astate,Tarea);
                printQ(Astate,Tarea);
                break;
            case 2:
                x1=this.theStates.get(2).getX1();
                x2=this.theStates.get(2).getX2();
                p=this.theStates.get(2).getP();
                mem=this.theStates.get(2).getWhichMemberId();
                mp=this.theStates.get(2).getWhichPoint();
                global1=this.themembers[mem-1].getPoint(mp).getId();
                lx=0.;
                switch(mp){
                    case 0: lx=0.; break;
                    case 1: lx=themembers[mem-1].getL(); break;
                }
                double Mp1=this.themembers[mem-1].getM(lx, x1, x2, p);
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(0, 1, H); theVector.set(0, 0, -Mp1);
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM1()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM1()[1]); theVector.addVal(1, 0, -this.themembers[i].getM1()[2]*Pval);
                        }
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(0, 0, L); theMatrix.set(0, 1, -(H+Hd)); theVector.set(0, 0, Mp1+Pval*L/2.);
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2_D()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2_D()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2_D()[2]*Pval);
                        }
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(0, 0, L+xd); theMatrix.set(0, 1, -(H+Hd-yd)); theVector.set(0, 0, Mp1+Pval*(L/2.+xd));
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2_Z()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2_Z()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2_Z()[2]*Pval);
                        }
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(0, 0, 2.*L); theMatrix.set(0, 1, -(H)); theVector.set(0, 0, Mp1+Pval*(3.*L/2.)+Pval*(Hd-yd));
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2_G()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2_G()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2_G()[2]*Pval);
                        }
                        break;
                    case 10:
                        theMatrix.set(0, 0, 2.*L); theVector.set(0, 0, Mp1+Pval*(3.*L/2.)+Pval*(H+Hd-yd));
                        for(int i=0;i<5;i++){
                            theMatrix.addVal(1, 0, this.themembers[i].getM2()[0]); theMatrix.addVal(1, 1, this.themembers[i].getM2()[1]); theVector.addVal(1, 0, -this.themembers[i].getM2()[2]*Pval);
                        }
                        break;
                }
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                //printSys(theMatrix, theVector, theSolution, 0, "none");
                dg=this.getDeltaG(x1_temp, x2_temp, Pval);
                Astate = new state(false, false, 0, 2, Pval, x1_temp, x2_temp, 1,dg);
                this.theStates.put(Astate.getId(), Astate);
                printM(Astate,Tarea);
                printN(Astate,Tarea);
                printQ(Astate,Tarea);
                break;
            case 3:
                x1=this.theStates.get(2).getX1();
                x2=this.theStates.get(2).getX2();
                p=this.theStates.get(2).getP();
                mem=this.theStates.get(2).getWhichMemberId();
                mp=this.theStates.get(2).getWhichPoint();
                global1=this.themembers[mem-1].getPoint(mp).getId();
                lx=0.;
                switch(mp){
                    case 0: lx=0.; break;
                    case 1: lx=themembers[mem-1].getL(); break;
                }
                Mp1=this.themembers[mem-1].getM(lx, x1, x2, p);
                x1=this.theStates.get(3).getX1();
                x2=this.theStates.get(3).getX2();
                p=this.theStates.get(3).getP();
                mem=this.theStates.get(3).getWhichMemberId();
                mp=this.theStates.get(3).getWhichPoint();
                global2=this.themembers[mem-1].getPoint(mp).getId();
                lx=0.;
                switch(mp){
                    case 0: lx=0.; break;
                    case 1: lx=themembers[mem-1].getL(); break;
                }
                double Mp2=this.themembers[mem-1].getM(lx, x1, x2, p);
                switch(global1){
                    case 2:
                    case 3:
                        theMatrix.set(0, 1, H); theVector.set(0, 0, -Mp1);
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(0, 0, L); theMatrix.set(0, 1, -(H+Hd)); theVector.set(0, 0, Mp1+Pval*L/2.);
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(0, 0, L+xd); theMatrix.set(0, 1, -(H+Hd-yd)); theVector.set(0, 0, Mp1+Pval*(L/2.+xd));
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(0, 0, 2.*L); theMatrix.set(0, 1, -(H)); theVector.set(0, 0, Mp1+Pval*(3.*L/2.)+Pval*(Hd-yd));
                        break;
                    case 10:
                        theMatrix.set(0, 0, 2.*L); theVector.set(0, 0, Mp1+Pval*(3.*L/2.)+Pval*(H+Hd-yd));
                        break;
                }
                switch(global2){
                    case 2:
                    case 3:
                        theMatrix.set(1, 1, H); theVector.set(1, 0, -Mp2);
                        break;
                    case 4:
                    case 5:
                        theMatrix.set(1, 0, L); theMatrix.set(1, 1, -(H+Hd)); theVector.set(1, 0, Mp2+Pval*L/2.);
                        break;
                    case 6:
                    case 7:
                        theMatrix.set(1, 0, L+xd); theMatrix.set(1, 1, -(H+Hd-yd)); theVector.set(1, 0, Mp2+Pval*(L/2.+xd));
                        break;
                    case 8:
                    case 9:
                        theMatrix.set(1, 0, 2.*L); theMatrix.set(1, 1, -(H)); theVector.set(1, 0, Mp2+Pval*(3.*L/2.)+Pval*(Hd-yd));
                        break;
                    case 10:
                        theMatrix.set(1, 0, 2.*L); theVector.set(1, 0, Mp2+Pval*(3.*L/2.)+Pval*(H+Hd-yd));
                        break;
                }
                LUofA = new LUDecomposition(theMatrix);
                theSolution=LUofA.solve(theVector);
                x1_temp=theSolution.get(0, 0);
                x2_temp=theSolution.get(1, 0);
                //printSys(theMatrix, theVector, theSolution, 0, "none");
                dg=this.getDeltaG(x1_temp, x2_temp, Pval);
                Astate = new state(false, false, 0, 2, Pval, x1_temp, x2_temp, 1,dg);
                this.theStates.put(Astate.getId(), Astate);
                printM(Astate,Tarea);
                printN(Astate,Tarea);
                printQ(Astate,Tarea);
                break;
        }
    }
}
