/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import core.*;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Iterator;
import javax.swing.JTable;

/**
 *
 * @author pchr
 */
public class StructurePanel extends DrawPanel{
    private int selectedState=-1;
    private int selectedSection=0; // 0 ZD, 1 ZD
    private int selectedVariable=0;
    private double xcoefScale=0.6;
    private double ycoefScale=0.6;
    private JTable Stable;
    public StructurePanel(){
        super();
    }
    
    @Override
    public void plot(){
        repaint();
    }
    
    @Override
    public void paintComponent(Graphics g) {
        //System.out.println("paintComponent");
	// Define graphics
        Graphics2D g2 = (Graphics2D) g;
        // Get dimensions
	int width  = this.getWidth();
	int height = this.getHeight();
	// Clear window
	g2.setBackground(Color.WHITE);
	g2.clearRect(0, 0, width, height);
        
        xm=width/2;
        xs=width/20;
        xe=width-width/20;
        ym=height/2;
        ys=height/20;
        ye=height-height/20;
        
        //g2.setColor(Color.RED);
        //g2.drawLine(xs, ym, xe, ym);
        //g2.drawLine(xm, ys, xm, ye);
       
        if(this.MainStructure!=null){
            ///////// LOGO
            g2.setColor(Color.RED);
            Font aFont=new Font("serif", Font.BOLD+Font.ITALIC, 24);
            g2.setFont(aFont);
            g2.drawString("jCastigliano", (xs+xs)/2, ys);
            g2.setColor(Color.BLACK);
            aFont=new Font("serif", Font.PLAIN, 10);
            g2.setFont(aFont);
            g2.drawString("Αντοχή Υλικών & Δομικών Στοιχείων ΙΙ", (xs+xs)/2, ys+20);
            ///////// END LOGO
            
            this.yscale=(xcoefScale*Math.abs(ys-ye))/(Math.abs(this.MainStructure.getH())+Math.tan(MainStructure.getAngle())*Math.abs(this.MainStructure.getL()));
            this.xscale=(ycoefScale*Math.abs(xs-xe))/(2.*Math.abs(this.MainStructure.getL()));

            at = new AffineTransform();
                    
            at.translate((xm+xe)/1.8, ye);
            //at.translate((xm+xe)/1.7, ye);
            //at.translate(xm, ye);
            
            at.rotate(Math.PI);
            
            at.scale(xscale, yscale);
            
            switch(this.selectedVariable){
                case 0:
                    this.drawLines(g2);
                    this.drawForces(g2);
                    this.drawHinges(g2);
                    this.drawLetters(g2);
                    break;
                case 1:
                    this.drawLines(g2);
                    this.drawState(g2);
                    this.drawLetters(g2);
                    break;
                case 2:
                    this.drawLines(g2);
                    this.drawState(g2);
                    this.drawLetters(g2);
                    break;
                case 3:
                    this.drawLines(g2);
                    this.drawState(g2);
                    this.drawLetters(g2);
                    break;
                case 4:
                    this.drawCurve(g2);
                    break;
                case 5:
                    this.drawSection(g2);
                    this.drawStateStress(g2);
                    break;
            }
                        
        } else{
            ///////// LOGO
            g2.setColor(Color.RED);
            Font aFont=new Font("serif", Font.BOLD+Font.ITALIC, 48);
            g2.setFont(aFont);
            g2.drawString("jCastigliano", (xm+xs)/2, ym-50);
            g2.setColor(Color.BLACK);
            aFont=new Font("serif", Font.PLAIN, 14);
            g2.setFont(aFont);
            g2.drawString("Αντοχή Υλικών & Δομικών Στοιχείων ΙΙ", (xm+xs)/2, ym);
            //Image img = Toolkit.getDefaultToolkit().getImage(java.net.URLClassLoader.getSystemResource("http://edusoft.civil.auth.gr/TE4500/jcastigliano/images/edusoft-logo01.png"));
            //g2.drawImage(img,0,0,this);
        }
    }
    
    public void drawLines(Graphics2D g2){
        int x1,x2,y1,y2;
        member[] StructureMembers= this.MainStructure.getMembers();
        Point2D.Double pointb,pointa;
        for(int i=0; i<StructureMembers.length;i++){
            member theMember = StructureMembers[i];
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(theMember.getP1().getX(),theMember.getP1().getY());
            at.transform(pointb, pointa);
            
            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 
            
            pointb = new Point2D.Double(theMember.getP2().getX(),theMember.getP2().getY());
            at.transform(pointb, pointa);
            
            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.setColor(Color.BLACK);
            g2.setStroke(new BasicStroke(1));
            g2.drawLine(x1, y1, x2, y2);
        }      
    }
    
        public void drawLetters(Graphics2D g2){
        int x1,x2,y1,y2;
        member[] StructureMembers= this.MainStructure.getMembers();
        Point2D.Double pointb,pointa;
        g2.setColor(Color.BLACK);
        for(int i=0; i<StructureMembers.length;i++){
            member theMember = StructureMembers[i];
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(theMember.getP1().getX(),theMember.getP1().getY());
            at.transform(pointb, pointa);
            
            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 
            
            pointb = new Point2D.Double(theMember.getP2().getX(),theMember.getP2().getY());
            at.transform(pointb, pointa);
            
            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            String p="O";
            int xp,yp;
            xp=x2; yp=y2;
            switch(i){
                case 0:p="Ε";xp=x2+5; yp=y2-5; break;
                case 1:p="Δ";xp=x2+5; yp=y2-5; break;
                case 2:p="Ζ";xp=x2-10; yp=y2-5; break;
                case 3:p="Γ";xp=x2-10; yp=y2-5; break;
                case 4:p="Α";xp=x2-10; yp=y2-5; break;
            }
            g2.drawString(p, xp, yp);
            if(i==0){
              g2.drawString("Β", x1+5, y1-5);  
            }
        }
        g2.setStroke(new BasicStroke(1));
        double L=MainStructure.getL();
        
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(-0.1*L,0.);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(0.1*L,0.);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        
        //////////
        g2.setColor(Color.RED);
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(2.*L-0.025*L,0.025*L);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(2.*L+0.025*L,-0.025*L);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(2.*L-0.025*L,-0.025*L);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(2.*L+0.025*L,0.025*L);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);        
    }

    private void drawCurve(Graphics2D g2) {
        int x1,x2,y1,y2;
        Point2D.Double pointb,pointa;
        int ns=this.Stable.getRowCount();
        double h=Double.parseDouble(this.Stable.getModel().getValueAt(ns-1, 1).toString());
        double b=Double.parseDouble(this.Stable.getModel().getValueAt(ns-1, 2).toString());
        
        AffineTransform at_temp = new AffineTransform();
        at_temp=at;
        
        this.yscale=(0.8*Math.abs(ys-ye))/(h);
        this.xscale=(0.9*Math.abs(xs-xe))/(b);

        at = new AffineTransform();

        at.translate(xe-this.getWidth()/30, ye-this.getHeight()/30);

        at.rotate(Math.PI);

        at.scale(xscale, yscale);
        
        g2.setColor(Color.BLACK);
        g2.setStroke(new BasicStroke(2));
        
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.,0.);
        at.transform(pointb, pointa);
        
        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(0.,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        
        //
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.,0.);
        at.transform(pointb, pointa);
        
        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(b,0.);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        
        g2.setStroke(new BasicStroke(1));
        pointb = new Point2D.Double(b-0.1*b,0.05*h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        g2.drawString("μετακίνηση σημείου Γ [cm]", x2, y2);
        
        pointb = new Point2D.Double(-0.01*b,h+0.05*h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        g2.drawString("P [kN]", x2, y2);

        
        
        g2.setColor(Color.BLUE);
        double x,y;
        String type;
        for(int i=1; i<this.MainStructure.getStates().size(); i++){
            pointa = new Point2D.Double();
            x=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 2).toString());
            y=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 1).toString());
            pointb = new Point2D.Double(x,y);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();

            x=Double.parseDouble(this.Stable.getModel().getValueAt(i, 2).toString());
            y=Double.parseDouble(this.Stable.getModel().getValueAt(i, 1).toString());
            type=this.Stable.getModel().getValueAt(i, 3).toString();
            pointb = new Point2D.Double(x,y);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            x=Double.parseDouble(this.Stable.getModel().getValueAt(i, 2).toString())+b/200.;
            y=Double.parseDouble(this.Stable.getModel().getValueAt(i, 1).toString())+h/200.;
            pointb = new Point2D.Double(x,y);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            
            x=Double.parseDouble(this.Stable.getModel().getValueAt(i, 2).toString())-b/200.;
            y=Double.parseDouble(this.Stable.getModel().getValueAt(i, 1).toString())-h/200.;
            pointb = new Point2D.Double(x,y);
            at.transform(pointb, pointa);
            
            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();
            
            if(type.equals("κατάρρευση")){g2.setColor(Color.RED);}else if(type.equals("διαρροή")){g2.setColor(Color.GREEN);}else{g2.setColor(Color.BLACK);}
            g2.drawLine(x1, y1, x2, y2);
            g2.setColor(Color.BLUE);
            
            x=Double.parseDouble(this.Stable.getModel().getValueAt(i, 2).toString())-b/200.;
            y=Double.parseDouble(this.Stable.getModel().getValueAt(i, 1).toString())+h/200.;
            pointb = new Point2D.Double(x,y);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            
            x=Double.parseDouble(this.Stable.getModel().getValueAt(i, 2).toString())+b/200.;
            y=Double.parseDouble(this.Stable.getModel().getValueAt(i, 1).toString())-h/200.;
            pointb = new Point2D.Double(x,y);
            at.transform(pointb, pointa);
            
            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();
            
            if(type.equals("κατάρρευση")){g2.setColor(Color.RED);}else if(type.equals("διαρροή")){g2.setColor(Color.GREEN);}else{g2.setColor(Color.BLACK);}
            g2.drawLine(x1, y1, x2, y2);
            
            g2.setColor(Color.BLUE);
            
            if(i==1){
                type=this.Stable.getModel().getValueAt(i-1, 3).toString();
                x=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 2).toString())+b/200.;
                y=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 1).toString())+h/200.;
                pointb = new Point2D.Double(x,y);
                at.transform(pointb, pointa);

                x1=(int) pointa.getX(); x1=mirrorX(x1);
                y1=(int) pointa.getY();

                x=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 2).toString())-b/200.;
                y=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 1).toString())-h/200.;
                pointb = new Point2D.Double(x,y);
                at.transform(pointb, pointa);

                x2=(int) pointa.getX(); x2=mirrorX(x2);
                y2=(int) pointa.getY();

                if(type.equals("κατάρρευση")){g2.setColor(Color.RED);}else if(type.equals("διαρροή")){g2.setColor(Color.GREEN);}else{g2.setColor(Color.BLACK);}
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLUE);

                x=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 2).toString())-b/200.;
                y=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 1).toString())+h/200.;
                pointb = new Point2D.Double(x,y);
                at.transform(pointb, pointa);

                x1=(int) pointa.getX(); x1=mirrorX(x1);
                y1=(int) pointa.getY();

                x=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 2).toString())+b/200.;
                y=Double.parseDouble(this.Stable.getModel().getValueAt(i-1, 1).toString())-h/200.;
                pointb = new Point2D.Double(x,y);
                at.transform(pointb, pointa);

                x2=(int) pointa.getX(); x2=mirrorX(x2);
                y2=(int) pointa.getY();

                if(type.equals("κατάρρευση")){g2.setColor(Color.RED);}else if(type.equals("διαρροή")){g2.setColor(Color.GREEN);}else{g2.setColor(Color.BLACK);}
                g2.drawLine(x1, y1, x2, y2);
                g2.setColor(Color.BLUE);
            }
        }
    }
    
    private void drawForces(Graphics2D g2){
        // sxediasi dinamis
        // kurios grami
        int x1,x2,y1,y2;
        Point2D.Double pointb,pointa;
        g2.setColor(Color.BLUE);
        g2.setStroke(new BasicStroke(1));
        double L=MainStructure.getL();
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(this.MainStructure.getMembers()[2].getP2().getX()-0.2*L,this.MainStructure.getMembers()[2].getP2().getY());
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(this.MainStructure.getMembers()[2].getP2().getX(),this.MainStructure.getMembers()[2].getP2().getY());
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        // velaki pano
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(this.MainStructure.getMembers()[2].getP2().getX(),this.MainStructure.getMembers()[2].getP2().getY());
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(this.MainStructure.getMembers()[2].getP2().getX()-0.05*L,this.MainStructure.getMembers()[2].getP2().getY()+0.01*L);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        // velaki kato
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(this.MainStructure.getMembers()[2].getP2().getX(),this.MainStructure.getMembers()[2].getP2().getY());
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(this.MainStructure.getMembers()[2].getP2().getX()-0.05*L,this.MainStructure.getMembers()[2].getP2().getY()-0.01*L);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        
        // sxediasi katanemimenou fortiou
        double Heg=MainStructure.getH();
        // kurios grami pano
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX(),this.MainStructure.getMembers()[1].getP2().getY());
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(this.MainStructure.getMembers()[0].getP2().getX(),this.MainStructure.getMembers()[1].getP2().getY());
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        // kurios grami kato
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX(),this.MainStructure.getMembers()[1].getP2().getY()+0.05*Heg);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY();

        pointb = new Point2D.Double(this.MainStructure.getMembers()[0].getP2().getX(),this.MainStructure.getMembers()[1].getP2().getY()+0.05*Heg);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        
        g2.drawLine(x1, y1, x2, y2);
        // kathetes
        double L2=MainStructure.getMembers()[1].getL()*Math.cos(MainStructure.getAngle());
        for(int i=0; i<=20;i++){
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX()+i*L2/20,this.MainStructure.getMembers()[1].getP2().getY()+0.05*Heg);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            
            pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX()+i*L2/20,this.MainStructure.getMembers()[1].getP2().getY());
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            // velos aristera
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX()+i*L2/20-0.01*L2,this.MainStructure.getMembers()[1].getP2().getY()+0.01*L2);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            
            pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX()+i*L2/20,this.MainStructure.getMembers()[1].getP2().getY());
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            // velos dexa
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX()+i*L2/20+0.01*L2,this.MainStructure.getMembers()[1].getP2().getY()+0.01*L2);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            
            pointb = new Point2D.Double(this.MainStructure.getMembers()[1].getP2().getX()+i*L2/20,this.MainStructure.getMembers()[1].getP2().getY());
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
        }
    }
    
    private void drawHinges(Graphics2D g2){
        int x1,x2,y1,y2;
        Point2D.Double pointb,pointa;
        double L=MainStructure.getL();
        for(Iterator<state> it=MainStructure.getStates().values().iterator(); it.hasNext();){
            state theState = it.next();
            int memId=theState.getWhichMemberId();
            int memLoc=theState.getWhichPoint();
            
            if(theState.getId()>1 && theState.getId()<=4){
                g2.setColor(Color.RED);
                pointa = new Point2D.Double();
                pointb = new Point2D.Double(MainStructure.getMembers()[memId-1].getPoint(memLoc).getX()-0.025*L,MainStructure.getMembers()[memId-1].getPoint(memLoc).getY()+0.025*L);
                at.transform(pointb, pointa);

                x1=(int) pointa.getX(); x1=mirrorX(x1);
                y1=(int) pointa.getY(); 

                pointb = new Point2D.Double(MainStructure.getMembers()[memId-1].getPoint(memLoc).getX()+0.025*L,MainStructure.getMembers()[memId-1].getPoint(memLoc).getY()-0.025*L);
                at.transform(pointb, pointa);

                x2=(int) pointa.getX(); x2=mirrorX(x2);
                y2=(int) pointa.getY();

                g2.drawLine(x1, y1, x2, y2);

                pointa = new Point2D.Double();
                pointb = new Point2D.Double(MainStructure.getMembers()[memId-1].getPoint(memLoc).getX()-0.025*L,MainStructure.getMembers()[memId-1].getPoint(memLoc).getY()-0.025*L);
                at.transform(pointb, pointa);

                x1=(int) pointa.getX(); x1=mirrorX(x1);
                y1=(int) pointa.getY();

                pointb = new Point2D.Double(MainStructure.getMembers()[memId-1].getPoint(memLoc).getX()+0.025*L,MainStructure.getMembers()[memId-1].getPoint(memLoc).getY()+0.025*L);
                at.transform(pointb, pointa);

                x2=(int) pointa.getX(); x2=mirrorX(x2);
                y2=(int) pointa.getY();

                g2.drawLine(x1, y1, x2, y2);
                switch(theState.getId()){
                    case 2: g2.drawString("πρώτη π.α.", x2+10, y2-10); break;
                    case 3: g2.drawString("δεύτερη π.α.", x2+10, y2-10); break;
                    case 4: g2.drawString("τρίτη π.α.", x2+10, y2-10); break;
                }
            }
        }
    }
    
    private void drawState(Graphics2D g2){
        int x1,x2,y1,y2;
        Point2D.Double pointb,pointa;
        double Var=0.;
        double MaxVal=0.;
        double X1,X2,P;
        int steps=20;
        // psaxno ia maxVal diagramaton
        if(selectedState>=0){
            X1=MainStructure.getStates().get(selectedState).getX1();
            X2=MainStructure.getStates().get(selectedState).getX2();
            P=MainStructure.getStates().get(selectedState).getP();
            for(int i=0;i<MainStructure.getMembers().length; i++){
                member Amember=MainStructure.getMembers()[i];
                for(int j=0; j<=steps; j++){
                    double xloc=j*Amember.getL()/((double)steps);
                    switch(selectedVariable){
                        case 1:
                            Var=Amember.getM(xloc,X1,X2,P);
                            if(MaxVal<Math.abs(Var)){MaxVal=Math.abs(Var);}
                            break;
                        case 2:
                            Var=Amember.getN(xloc,X1,X2,P);
                            if(MaxVal<Math.abs(Var)){MaxVal=Math.abs(Var);}
                            break;
                        case 3:
                            Var=Amember.getQ(xloc,X1,X2,P);
                            if(MaxVal<Math.abs(Var)){MaxVal=Math.abs(Var);}
                            break;
                    }
                }
            }
        }
        if(Math.abs(MaxVal)<1.e-10){MaxVal=1.;}
        double dx1,dy1,dxv,dyv,dxl,dyl,dx2,dy2;
        double dxvp,dyvp; dxvp=0.0; dyvp=0.0;
        double A,B,D,K,G,Z;
        DecimalFormatSymbols comma =new DecimalFormatSymbols();
        comma.setDecimalSeparator('.');
        DecimalFormat Places = new DecimalFormat("0.000",comma);
        String sd;
        // vrika ti max maxVal , pame gia sxediasi
        if(selectedState>=0){
            //this.OutTextArea.append("----------------------------"+'\n');
            X1=MainStructure.getStates().get(selectedState).getX1();
            X2=MainStructure.getStates().get(selectedState).getX2();
            P=MainStructure.getStates().get(selectedState).getP();
            for(int i=0;i<MainStructure.getMembers().length; i++){
                member Amember=MainStructure.getMembers()[i];
                for(int j=0; j<=steps; j++){
                    double xloc=j*Amember.getL()/(double)steps;
                    switch(selectedVariable){
                        case 1:
                            Var=Amember.getM(xloc,X1,X2,P);
                            break;
                        case 2:
                            Var=Amember.getN(xloc,X1,X2,P);
                            break;
                        case 3:
                            Var=Amember.getQ(xloc,X1,X2,P);
                            break;
                    }
                    // tora edo exo to entatiko megethos kai 
                    // to simeio sto opoio anikei epi tou melous
                    // menei na to sxediaso
                    int sn=this.selectedState;
                    sd=Places.format(MainStructure.getStates().get(sn).getP());
                    g2.drawString("κατάσταση:"+sn+" ,φορτίο:"+sd, (xs+xs)/2, ys+40);
                    
                    dx1=Amember.getP1().getX(); dy1=Amember.getP1().getY();
                    dx2=Amember.getP2().getX(); dy2=Amember.getP2().getY();
                    dxl=dx1+j/((double)steps)*Amember.getL()*Amember.getMemberCosAngle();
                    dyl=dy1+j/((double)steps)*Amember.getL()*Amember.getMemberSinAngle();
                    A=dy1-dy2;
                    B=dx2-dx1;
                    G=dx1*dy2-dx2*dy1;
                    G=-G+Math.sqrt(A*A+B*B)*0.5*MainStructure.getL()*Var/MaxVal;
                    D=dx2-dx1; K=dy2-dy1; Z=dxl*(dx2-dx1)+dyl*(dy2-dy1);
                    dxv=(G*K-B*Z)/(A*K-B*D); dyv=(A*Z-D*G)/(A*K-B*D);
                    ///////////////////////////
                    pointa = new Point2D.Double();
                    pointb = new Point2D.Double(dxl,dyl);
                    at.transform(pointb, pointa);

                    x1=(int) pointa.getX(); x1=mirrorX(x1);
                    y1=(int) pointa.getY(); 

                    pointb = new Point2D.Double(dxv,dyv);
                    at.transform(pointb, pointa);

                    x2=(int) pointa.getX(); x2=mirrorX(x2);
                    y2=(int) pointa.getY();

                    g2.setColor(Color.blue);
                    g2.setStroke(new BasicStroke(1));
                    g2.drawLine(x1, y1, x2, y2);
                    ///////////////////////////
                    
                    ///////////////////////////
                    if(j>0){
                        pointa = new Point2D.Double();
                        pointb = new Point2D.Double(dxvp,dyvp);
                        at.transform(pointb, pointa);

                        x1=(int) pointa.getX(); x1=mirrorX(x1);
                        y1=(int) pointa.getY(); 

                        pointb = new Point2D.Double(dxv,dyv);
                        at.transform(pointb, pointa);

                        x2=(int) pointa.getX(); x2=mirrorX(x2);
                        y2=(int) pointa.getY();

                        g2.setColor(Color.blue);
                        g2.setStroke(new BasicStroke(1));
                        g2.drawLine(x1, y1, x2, y2);
                    }
                    
                    ///////////////////////////
                    dxvp=dxv; dyvp=dyv;
                    if(j==0){
                        g2.setColor(Color.BLACK);
                        pointa = new Point2D.Double();
                        pointb = new Point2D.Double(dxv,dyv);
                        at.transform(pointb, pointa);

                        x1=(int) pointa.getX(); x1=mirrorX(x1);
                        y1=(int) pointa.getY();
                        sd=Places.format(Var);
                        Font aFont=g2.getFont();
                        int fs=g2.getFont().getSize();
                        aFont=new Font("serif", Font.BOLD, fs+4);
                        g2.setFont(aFont);
                        fs=g2.getFont().getSize();
                        g2.setStroke(new BasicStroke(2));
                        g2.drawString(sd, x1-10, y1-10);
                        aFont=new Font("serif", Font.PLAIN, fs-4);
                        g2.setFont(aFont);
                        g2.setStroke(new BasicStroke(1));
                        //this.OutTextArea.append(sd+" ");
                    }
                    if(j==steps){
                        g2.setColor(Color.BLACK);
                        pointa = new Point2D.Double();
                        pointb = new Point2D.Double(dxv,dyv);
                        at.transform(pointb, pointa);
                        
                        x1=(int) pointa.getX(); x1=mirrorX(x1);
                        y1=(int) pointa.getY();
                        sd=Places.format(Var);
                        Font aFont=g2.getFont();
                        int fs=g2.getFont().getSize();
                        aFont=new Font("serif", Font.BOLD, fs+4);
                        g2.setFont(aFont);
                        fs=g2.getFont().getSize();
                        g2.setStroke(new BasicStroke(2));
                        g2.drawString(sd, x1+10, y1+10);
                        aFont=new Font("serif", Font.PLAIN, fs-4);
                        g2.setFont(aFont);
                        g2.setStroke(new BasicStroke(1));
                        //this.OutTextArea.append(sd+'\n');
                    }
                }
            }
        }
    }
    
    public void drawSection(Graphics2D g2){
        int x1,x2,y1,y2;
        DoubleTauSect theSection = (DoubleTauSect) this.MainStructure.getMembers()[3].getSection();
        Point2D.Double pointb,pointa;
        double t=theSection.get_t();
        double b=theSection.get_b();
        double s=theSection.get_s();
        double h=theSection.getHeight();
        
        AffineTransform at_temp = new AffineTransform();
        at_temp=at;
        
        this.yscale=(0.7*Math.abs(ys-ye))/(h);
        this.xscale=(0.5*Math.abs(xs-xe))/(b);

        at = new AffineTransform();

        at.translate(xe, ye-this.getHeight()/30);

        at.rotate(Math.PI);

        at.scale(yscale, yscale);
        
        g2.setColor(Color.BLACK);
        g2.setStroke(new BasicStroke(1));
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.0,0.0);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b,0.);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);    
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b,0.);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b,t);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2); 
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b,t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b/2.+s/2.,t);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b/2.+s/2.,t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b/2.+s/2.,h-t);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b/2.+s/2.,h-t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b,h-t);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b,h-t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b,h);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.,h-t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.,h-t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b/2.-s/2.,h-t);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b/2.-s/2.,h-t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(b/2.-s/2.,t);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(b/2.-s/2.,t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.,t);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        /////
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.,t);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.,0.);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        // TASEIS
        g2.setColor(Color.GRAY);
        
        //
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.+3*b,0.);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.+3*b,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        pointb = new Point2D.Double(3*b,1.1*h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        g2.drawString("ορθές τάσεις (MPa)", x2, y2);
        
        //
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.+6*b,0.);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.+6*b,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        //
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.+6*b,0.);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.+5*b,0.);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        //
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.+6*b,0.);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.+7*b,0.);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        //
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.+6*b,h);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.+5*b,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        //
        pointa = new Point2D.Double();
        pointb = new Point2D.Double(0.+6*b,h);
        at.transform(pointb, pointa);

        x1=(int) pointa.getX(); x1=mirrorX(x1);
        y1=(int) pointa.getY(); 

        pointb = new Point2D.Double(0.+7*b,h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();

        g2.drawLine(x1, y1, x2, y2);
        
        pointb = new Point2D.Double(6*b,1.1*h);
        at.transform(pointb, pointa);

        x2=(int) pointa.getX(); x2=mirrorX(x2);
        y2=(int) pointa.getY();
        g2.drawString("διατμητικές τάσεις (MPa)", x2, y2);
    }
    
    public void drawStateStress(Graphics2D g2){
        int x1,x2,y1,y2;
        DoubleTauSect theSection = (DoubleTauSect) this.MainStructure.getMembers()[3].getSection();
        Point2D.Double pointb,pointa;
        double t=theSection.get_t();
        double b=theSection.get_b();
        double s=theSection.get_s();
        double h=theSection.getHeight();
        
        AffineTransform at_temp = new AffineTransform();
        at_temp=at;
        
        this.yscale=(0.7*Math.abs(ys-ye))/(h);
        this.xscale=(0.5*Math.abs(xs-xe))/(b);

        at = new AffineTransform();

        at.translate(xe, ye-this.getHeight()/30);

        at.rotate(Math.PI);

        at.scale(yscale, yscale);
        
        g2.setColor(Color.BLUE);
        g2.setStroke(new BasicStroke(1));
        
        if(selectedState>=0){
            DecimalFormatSymbols comma =new DecimalFormatSymbols();
            comma.setDecimalSeparator('.');
            DecimalFormat Places = new DecimalFormat("0.000",comma);
            String sd;
            ///////
            int sn=this.selectedState;
            sd=Places.format(MainStructure.getStates().get(sn).getP());
            g2.drawString("κατάσταση:"+sn+" ,φορτίο:"+sd, (xs+xs)/2, ys+40);
            g2.drawString("!! Το διάγραμμα ορθών τάσεων ισχύει για ελαστική συμπριφορά της διατομής", (xs+xs)/2, ys+60);
            ///////
            double X1=this.MainStructure.getStates().get(selectedState).getX1();
            double X2=this.MainStructure.getStates().get(selectedState).getX2();
            double P=this.MainStructure.getStates().get(selectedState).getP();
            int sec=3;
            double to=0.;
            double L2;
            switch(this.selectedSection){
                case 0:
                    sec=3;
                    L2=this.MainStructure.getMembers()[sec].getL();
                    to=0.;
                    break;
                case 1:
                    sec=2;
                    L2=this.MainStructure.getMembers()[sec].getL();
                    to=L2;
                    break;
            }
            
            double M=this.MainStructure.getMembers()[sec].getM(to, X1, X2, P);
            double N=this.MainStructure.getMembers()[sec].getN(to, X1, X2, P);
            double Q=this.MainStructure.getMembers()[sec].getQ(to, X1, X2, P);
            double A=MainStructure.getMembers()[sec].getSection().getA();
            double I=MainStructure.getMembers()[sec].getSection().getI();
            
            double skato=N/A+M/I*h/2.; skato/=1000.;
            double spano=N/A-M/I*h/2.; spano/=1000.;
            
            double smax=Math.max(Math.abs(skato),Math.abs(spano));
            if(Math.abs(smax)<1.e-10){smax=1.;}
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(3*b,0.);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(3*b+skato*b/smax,0.);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(3*b+skato*b/smax,0.-0.02*h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            sd=Places.format(skato);
            g2.drawString(sd, x1, y1);
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(3*b+skato*b/smax,0.);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(3*b+spano*b/smax,h);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(3*b+spano*b/smax,h+0.02*h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            sd=Places.format(spano);
            g2.drawString(sd, x1, y1);
            
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(3*b+spano*b/smax,h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(3*b,h);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(3*b+skato*b/smax,0.-0.02*h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            sd=Places.format(skato);
            g2.drawString(sd, x1, y1);
            
            // DIATMISI
            double hh=h/1.5;
            double sy1=0.5*(b-s)*t*(0.75*hh-0.5*t);
            double sy2=b*t*(0.75*hh-0.5*t);
            double sy3=sy2+0.5*s*(0.75*hh-t)*(0.75*hh-t);
            
            double aQ=Math.abs(Q);
            double t1=aQ*sy1/(t*I)/1000.;
            smax=Math.abs(t1);
            double t2=aQ*sy2/(s*I)/1000.;
            if(Math.abs(t2)>smax){smax=Math.abs(t2);}
            double t3=aQ*sy3/(s*I)/1000.;
            if(Math.abs(t3)>smax){smax=Math.abs(t3);}
            if(Math.abs(smax)<1.e-10){smax=1.;}
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6*b,h+t1*b/smax);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(7.*b,h);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6*b,h+t1*b/smax);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(5.*b,h);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6.1*b,h+t1*b/smax+0.01*h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            sd=Places.format(t1);
            g2.drawString(sd, x1, y1);
            
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6*b,-t1*b/smax);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(7.*b,0);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6*b,-t1*b/smax);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(5.*b,0);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6.1*b,-0.01*h-t1*b/smax);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            sd=Places.format(t1);
            g2.drawString(sd, x1, y1);
            
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6*b,h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(6.*b+t2*b/smax,h);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6*b,0);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(6.*b+t2*b/smax,0);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(Math.max(7.1*b, 6.2*b+t2*b/smax),h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            sd=Places.format(t2);
            g2.drawString(sd, x1, y1);
            
            // apo edo xekinao na sxediazo ti duterovathmia
            //
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6*b,h/2.);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(6.*b+t3*b/smax,h/2.);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            g2.drawLine(x1, y1, x2, y2);
            
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(Math.max(7.1*b, 6.2*b+t3*b/smax),h/2.);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY();
            sd=Places.format(t3);
            g2.drawString(sd, x1, y1);
            
            
            //////
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6.*b+t2*b/smax,h);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(6.*b+t3*b/smax,h/2.);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            //g2.drawLine(x1, y1, x2, y2);
            //////
            pointa = new Point2D.Double();
            pointb = new Point2D.Double(6.*b+t2*b/smax,0.);
            at.transform(pointb, pointa);

            x1=(int) pointa.getX(); x1=mirrorX(x1);
            y1=(int) pointa.getY(); 

            pointb = new Point2D.Double(6.*b+t3*b/smax,h/2.);
            at.transform(pointb, pointa);

            x2=(int) pointa.getX(); x2=mirrorX(x2);
            y2=(int) pointa.getY();

            //g2.drawLine(x1, y1, x2, y2);
            
            double av=t2*b/smax;
            double mv=t3*b/smax;
            double ac=4.*(av-mv)/(h*h);
            double bc=-4.*(av-mv)/(h);
            double cc=av;
            for(int is=0; is<10; is++){
              //////
                pointa = new Point2D.Double();
                pointb = new Point2D.Double(6.*b+(ac*(is*h/10)*(is*h/10)+bc*(is*h/10)+cc),is*h/10);
                at.transform(pointb, pointa);

                x1=(int) pointa.getX(); x1=mirrorX(x1);
                y1=(int) pointa.getY(); 

                pointb = new Point2D.Double(6.*b+(ac*((is+1)*h/10)*((is+1)*h/10)+bc*((is+1)*h/10)+cc),(is+1)*h/10);
                at.transform(pointb, pointa);

                x2=(int) pointa.getX(); x2=mirrorX(x2);
                y2=(int) pointa.getY();

                g2.drawLine(x1, y1, x2, y2);
            }
        }
    }
    
    private int mirrorX(int x){
        return 2*xm-x;
    }
    
    public void setSelectedState(int s){
        int s1=s;
        if(s1>0){
            s=this.MainStructure.getStates().get(s1).getId();
            //System.out.print(s1+" ");System.out.println(this.MainStructure.getStates().get(s1).getP());
            this.selectedState=s;
        }
        
    }
    
    public void setSelectedVariable(int s){
         this.selectedVariable=s;
    }
    
    public void setSelectedSection(int s){
         this.selectedSection=s;
    }
    
    public void Initialize(){
        selectedState=-1;
        selectedVariable=0;
    }
    
    public double getXscale(){
        return this.xcoefScale;
    }
    
    public double getYscale(){
        return this.ycoefScale;
    }
    
    public void setXscale(double val){
        this.xcoefScale=val;
    }
    
    public void setYscale(double val){
        this.ycoefScale=val;
    }
    
    public void setStateTable(JTable table){
        this.Stable=table;
    }

}
